<?php
  // security check
  require_once "secureLogin.php";
  require_once "cmvar.php";
  
	// 20090518 - Remove Start
	// version control
	if (substr_count(strtolower($version), 'standard') > 0) {
        if (substr_count(strtolower($version),'donation')>0)
            $version = substr($version,0,strlen($version)-9);
        $disabled = ' disabled';
        $version_msg = '<span>* This feature is not available in '. ucwords($version) .' Edition.</span>';
        $version_star = '<span class="star">* </span>';
    } else {
        $disabled = '';
        $version_msg = '';
        $version_star = '';
    }
  
  //NAT Save
  if(isset($c_Nat_save) && $c_Nat_save=="true") {
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('c_Nat.php FSCONFIG.Cfgmgr Object cannot be created!');
      
    if(isset($nat_enabled)) {
      $settingobj->setKey($nat_enabled, 'Enable', 'NAT');
      
      if($nat_enabled==1)
      	$settingobj->setKey('0', 'ip_num', 'proxyARP');
    }
    
    if(isset($nat_option))
      $settingobj->setKey($nat_option, 'Type', 'NAT');
  	
    
    //NAT IP address Mapping
    //Add entries
    if(isset($ser_ipS_array)) {
      $ipS_array = unserialize($ser_ipS_array);
      $ipE_array = unserialize($ser_ipE_array);
      $mask_array = unserialize($ser_mask_array);
        
      $NATcount = $settingobj->getKey('NAT_AddrR_Count', 'NAT');
        
      for($i=0; $i<count($ipS_array); $i++) {
        $pos=$NATcount+$i;
        $settingobj->setKey($ipS_array[$i],'NAT_AddrR_ipS_'.$pos, 'NAT');
        $settingobj->setKey($ipE_array[$i],'NAT_AddrR_ipE_'.$pos, 'NAT');
        $settingobj->setKey($mask_array[$i],'NAT_AddrR_mask_'.$pos, 'NAT');
      }
        
      $settingobj->setKey($NATcount+count($ipS_array),'NAT_AddrR_Count', 'NAT');
    }
    
    //Delete entries
    if(isset($ser_ipdelete_array)) {
      $ipdelete_array = unserialize($ser_ipdelete_array);
      
      $NATcount = $settingobj->getKey('NAT_AddrR_Count', 'NAT');
        
      for ($i=0; $i<$NATcount; $i++) {
        $ipS_array[$i] = $settingobj->getKey('NAT_AddrR_ipS_'.$i, 'NAT');
        $ipE_array[$i] = $settingobj->getKey('NAT_AddrR_ipE_'.$i, 'NAT');
        $mask_array[$i] = $settingobj->getKey('NAT_AddrR_mask_'.$i, 'NAT');
      }
        
      for($i=0; $i<count($ipdelete_array); $i++) {
        $ipS_array[$ipdelete_array[$i]] = "";
        $ipE_array[$ipdelete_array[$i]] = "";
        $mask_array[$ipdelete_array[$i]] = "";
      }
        
      $pos=0;
      for ($i=0; $i<$NATcount; $i++) {
        if($ipS_array[$i] != "") {
          $settingobj->setKey($ipS_array[$i],'NAT_AddrR_ipS_'.$pos, 'NAT');
          $settingobj->setKey($ipE_array[$i],'NAT_AddrR_ipE_'.$pos, 'NAT');
          $settingobj->setKey($mask_array[$i],'NAT_AddrR_mask_'.$pos, 'NAT');
          $pos++;
        }
      }
        
      $settingobj->setKey($NATcount-count($ipdelete_array),'NAT_AddrR_Count', 'NAT');
    }
    
    session_unregister('ser_ipS_array');
    session_unregister('ser_ipE_array');
    session_unregister('ser_mask_array');
    session_unregister('ser_ipdelete_array');  
    
    
    //NAT Port Forwarding
    //Add entries
    if(isset($ser_ipport_array)) {
	  $ipport_array = unserialize($ser_ipport_array);
	  $privatePort_array = unserialize($ser_privatePort_array);
	  $publicPort_array = unserialize($ser_publicPort_array);
	  $proto_array = unserialize($ser_proto_array);
	  
	  $NAT_portmap_count = $settingobj->getKey('NAT_portmap_count', 'NAT');
        
      for($i=0; $i<count($ipport_array); $i++) {
        $pos=$NAT_portmap_count+$i;
     
        $portmap = "$proto_array[$i]:$ipport_array[$i]:$privatePort_array[$i]:$publicPort_array[$i]";
        $settingobj->setKey($portmap,'NAT_portmap_'.$pos, 'NAT');
      }
        
      $settingobj->setKey($NAT_portmap_count+count($ipport_array),'NAT_portmap_Count', 'NAT');
    }
    
    //delete entries
    if(isset($ser_ipport_delete_array)) {
      $ipport_delete_array = unserialize($ser_ipport_delete_array);
      
      $NAT_portmap_count = $settingobj->getKey('NAT_portmap_count', 'NAT');
        
      for ($i=0; $i<$NAT_portmap_count; $i++) {
        $portmap_array[$i] = $settingobj->getKey('NAT_portmap_'.$i, 'NAT');
      }
        
      for($i=0; $i<count($ipport_delete_array); $i++) {
        $portmap_array[$ipport_delete_array[$i]] = "";
      }
        
      $pos=0;
      for ($i=0; $i<$NAT_portmap_count; $i++) {	    
        if($portmap_array[$i] != "") {
          $settingobj->setKey($portmap_array[$i],'NAT_portmap_'.$pos, 'NAT');
          $pos++;
        }
      }
        
      $settingobj->setKey($NAT_portmap_count-count($ipport_delete_array),'NAT_portmap_count', 'NAT');
    }
    
    session_unregister('ser_ipport_array');
  	session_unregister('ser_privatePort_array');
  	session_unregister('ser_publicPort_array');
  	session_unregister('ser_proto_array');
  	session_unregister('ser_ipport_delete_array');
    
    
    //$settingobj->Release();
    $settingobj=null;
  }
  
  if(isset($c_Nat_save) && $c_Nat_save=="true") {
	$_SESSION['message'] = 'All changes will take effect when you start FirstSpot&reg next time.';
    $_SESSION['error'] = '';
    $_SESSION['errorlog'] = '';
    echo "<script type='text/javascript'>parent.mid_right_bottom.location.reload();</script>";
  }
  //NAT Save End
  
  
  //ProxyARP Save
  if(isset($c_Nat_save) && $c_Nat_save=="true") {
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('c_Nat.php FSCONFIG.Cfgmgr Object cannot be created!');
    
    if(isset($proxyARP_enabled) && $proxyARP_enabled==0)
      $settingobj->setKey('0', 'ip_num', 'proxyARP');   	
    
    //add ProxyARP entries
    if(isset($ser_ip_array) && isset($proxyARP_enabled) && $proxyARP_enabled==1) {
      $ip_array = unserialize($ser_ip_array);
      
      $ProxyARPcount = $settingobj->getKey('ip_num', 'proxyARP');
      
      for($i=0; $i<count($ip_array); $i++) {
        $pos=$ProxyARPcount+$i;
        $settingobj->setKey($ip_array[$i], 'ip_addr'.$pos, 'proxyARP');
      }
      
      $settingobj->setKey($ProxyARPcount+count($ip_array), 'ip_num', 'proxyARP');
      
      session_unregister('ser_ip_array');
    }
    
    //delete ProxyARP entries
    if(isset($ser_ipdeleteProxyARP_array) && isset($proxyARP_enabled) && $proxyARP_enabled==1) {
      $ipdeleteProxyARP_array = unserialize($ser_ipdeleteProxyARP_array);
      
      $ProxyARPcount = $settingobj->getKey('ip_num', 'proxyARP');
      
      for ($i=0; $i<$ProxyARPcount; $i++)
        $ip_array[$i] = $settingobj->getKey('ip_addr'.$i, 'proxyARP');
        
      for($i=0; $i<count($ipdeleteProxyARP_array); $i++)
        $ip_array[$ipdeleteProxyARP_array[$i]] = "";
        
      $pos=0;
      for ($i=0; $i<$ProxyARPcount; $i++) {
        if($ip_array[$i] != "") {
          $settingobj->setKey($ip_array[$i],'ip_addr'.$pos, 'proxyARP');
          $pos++;
        }
      }
      
      $settingobj->setKey($ProxyARPcount-count($ipdeleteProxyARP_array),'ip_num', 'proxyARP');
      
      session_unregister('ser_ipdeleteProxyARP_array');  
    }
    
    $ProxyARPcount = $settingobj->getKey('ip_num', 'proxyARP');
    if($ProxyARPcount>0) {
    	$settingobj->setKey('0', 'Enable', 'NAT');
    	//$settingobj->setKey('0', 'NAT_AddrR_Count', 'NAT');
  	}
    
    //$settingobj->Release();
    $settingobj=null;
  }
  //ProxyARP Save
  
  //Cancel
  if(isset($c_Nat_cancel) && $c_Nat_cancel=="true") {
    session_unregister('ser_ipS_array');
    session_unregister('ser_ipE_array');
    session_unregister('ser_mask_array');
    session_unregister('ser_ipdelete_array');
    
    session_unregister('ser_ip_array');
    session_unregister('ser_ipdeleteProxyARP_array');
    
    session_unregister('ser_ipport_array');
  	session_unregister('ser_privatePort_array');
  	session_unregister('ser_publicPort_array');
  	session_unregister('ser_proto_array');
  	session_unregister('ser_ipport_delete_array');
  }
  
  
  $settingobj = new COM('FSCONFIG.Cfgmgr') or die('c_Nat.php FSCONFIG.Cfgmgr Object cannot be created!');
  $NAT_enabled = $settingobj->getKey('Enable', 'NAT');
  $NAT_type = $settingobj->getKey('Type', 'NAT');
  $NATcount = $settingobj->getKey('NAT_AddrR_Count', 'NAT');
  $ProxyARP_enabled = $settingobj->getKey('ip_num', 'proxyARP');
  
  if ($NAT_enabled==1) {
    $eNAT_checked = "checked";
    $dNAT_checked = "";
  } else {
    $eNAT_checked = "";
    $dNAT_checked = "checked";    
  }
  
  if ($ProxyARP_enabled > 0) {
    $eProxyARP_checked = "checked";
    $dProxyARP_checked = "";
  } else {
    $eProxyARP_checked = "";
    $dProxyARP_checked = "checked";   
  }
  
  //$settingobj->Release();
  $settingobj=null;
?>
<link rel="stylesheet" href="setcfg.css" type="text/css" />

<?= gen_license_warning($version_msg); ?>

<script type="text/javascript" src="./javascript/nat.js"></script>

<form name="c_Nat" action="" method="post">
<!-- NAT Header -->
<tr>
    <td width="400"><p class="indented">
        <img src="./images/smallbubble.gif" width="8" height="8">
        <img src="./images/blank.gif" width="10" height="6"><?=$version_star.get_cm_var('setcfg_nat_NAT')?>
    </td>
    <td width="50"><img src="./images/blank.gif" width="3" height="3"></td>
    <td width="300" class="normal">
    <input type="radio" name="nat_enabled" value="1" onclick="SwitchNAT(this)" <?=$disabled?> <?=$eNAT_checked?> <?=($ProxyARP_enabled>0)?"disabled":""?> ><?=get_cm_var('setcfg_nat_enabled')?>
    <input type="radio" name="nat_enabled" value="0" onclick="SwitchNAT(this)" <?=$disabled?> <?=$dNAT_checked?> <?=($ProxyARP_enabled>0)?"disabled":""?> ><?=get_cm_var('setcfg_nat_disabled')?>
    </td>
</tr>

<tr id="NatRadioButtons" style="display: <?=($NAT_enabled==1)?'':'none'?>;">
	<td width="400" class="normal">
		&nbsp;&nbsp;&nbsp;&nbsp;
		<input type="radio" name="nat_option" value="0" onclick="NatOption(this)" <?=$NAT_type==0? "checked" : ""?> ><?=get_cm_var('setcfg_nat_none')?>
		<input type="radio" name="nat_option" value="1" onclick="NatOption(this)" <?=$NAT_type==1? "checked" : ""?> <?=$disabled?> ><?=get_cm_var('setcfg_nat_address_mapping')?>
		<input type="radio" name="nat_option" value="2" onclick="NatOption(this)" <?=$NAT_type==2? "checked" : ""?> <?=$disabled?> ><?=get_cm_var('setcfg_nat_port_mapping')?>
	</td>
</tr>

<!-- NAT Address Mapping -->
<tr id="NatAddrRange" align="center" style="display: <?=($NAT_enabled==1)&&($NAT_type==1)?'':'none'?>" >
    <td width="100%" colspan="4" align="left">  
    <br>
    <table>
    <tr>
    <td style="font-size: 0.9em;">
        <?=get_cm_var('setcfg_select_label')?>&nbsp;
        <a href="" title="<?=get_cm_var('setcfg_selectAll_desc')?>" onclick="return selectAll(self.frames.frameNAT.document.getElementsByName('entry'));"><font size="2" color="blue"><?=get_cm_var('setcfg_selectAll_button')?></font></a>&nbsp;
        <a href="" title="<?=get_cm_var('setcfg_selectClear_desc')?>" onclick="return selectClear(self.frames.frameNAT.document.getElementsByName('entry'));"><font size="2" color="blue"><?=get_cm_var('setcfg_selectClear_button')?></font></a>&nbsp;
        <input type="button" value="<?=get_cm_var('setcfg_delete_button')?>" title="<?=get_cm_var('setcfg_delete_button')?>" class="graphicBtn" onclick="deleteEntry()" <?=$disabled?> >&nbsp;&nbsp;<font id="NATdeleteTxt" size="3" color="red" style="display: none"><?=get_cm_var('setcfg_confirm_delete_txt')?></font>
    </td>
    </tr>
    
    <tr>
    <td>
    <!-- 20080314 - Remove scrolling limitation -->
    <iframe id="frameNAT" name="frameNAT" class="bordered_frame" frameborder="0" width="400" height="206" src="frameNAT.php" marginwidth="0" marginheight="0"></iframe>
    </td>
    
    <td valign="bottom">
    <!--<form action="" name="formNAT" method="post" align="left" onsubmit="">-->
        <font class="captionbig"><?=get_cm_var('setcfg_nat_RealIPRange_start')?></font>
        <input class="IPtextbox" type="text" name="NAT_start_ip1" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_start_ip2')" <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="NAT_start_ip2" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_start_ip3')" <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="NAT_start_ip3" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_start_ip4')" <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="NAT_start_ip4" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_start_ip1')" <?=$disabled?> >
        <br><font class="captionbig"><?=get_cm_var('setcfg_nat_RealIPRange_end')?></font>
        <input class="IPtextbox" type="text" name="NAT_end_ip1" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_end_ip2')" <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="NAT_end_ip2" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_end_ip3')" <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="NAT_end_ip3" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_end_ip4')" <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="NAT_end_ip4" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_end_ip1')" <?=$disabled?> >
        <br><font class="captionbig"><?=get_cm_var('setcfg_nat_mask')?></font>
        <input class="IPtextbox" type="text" name="NAT_mask_ip1" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_mask_ip2')" <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="NAT_mask_ip2" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_mask_ip3')" <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="NAT_mask_ip3" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_mask_ip4')" <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="NAT_mask_ip4" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_mask_ip1')" <?=$disabled?> >
        <input type="button" value="<?=get_cm_var('setcfg_add_button')?>" title="<?=get_cm_var('setcfg_add_button')?>" class="graphicBtn" style="margin-left: 15px;" onclick="return addEntry();" <?=$disabled?> >
    </td>
    </tr>
    </table>
    <br>
    </td>

</tr>

<!-- NAT Port Forwarding -->
<tr id="NatPortMapping" align="center" style="display: <?=($NAT_enabled==1)&&($NAT_type==2)?'':'none'?>" >
    <td width="100%" colspan="4" align="left">  
    <br>
    <table>
    <tr>
    <td style="font-size: 0.9em;">
        <?=get_cm_var('setcfg_select_label')?>&nbsp;
        <a href="" title="<?=get_cm_var('setcfg_selectAll_desc')?>" onclick="return selectAll(self.frames.framePortMap.document.getElementsByName('entry'));"><font size="2" color="blue"><?=get_cm_var('setcfg_selectAll_button')?></font></a>&nbsp;
        <a href="" title="<?=get_cm_var('setcfg_selectClear_desc')?>" onclick="return selectClear(self.frames.framePortMap.document.getElementsByName('entry'));"><font size="2" color="blue"><?=get_cm_var('setcfg_selectClear_button')?></font></a>&nbsp;
        <input type="button" value="<?=get_cm_var('setcfg_delete_button')?>" title="<?=get_cm_var('setcfg_delete_button')?>" class="graphicBtn" onclick="deletePortMap()" <?=$disabled?> >&nbsp;&nbsp;<font id="NAT_portmap_deleteTxt" size="3" color="red" style="display: none"><?=get_cm_var('setcfg_confirm_delete_txt')?></font>
    </td>
    </tr>
    
    <tr>
    <td>
    <!-- 20080314 - Remove scrolling limitation -->
    <iframe id="framePortMap" name="framePortMap" class="bordered_frame" frameborder="0" width="400" height="206" src="framePortMap.php" marginwidth="0" marginheight="0"></iframe>
    </td>
    
    <td valign="bottom" nowrap>
    <!--<form action="" name="formNAT" method="post" align="left" onsubmit="">-->
    	<font class="captionbig"><?=get_cm_var('setcfg_nat_public_port')?></font>
    	<input class="Porttextbox" type="text" name="NAT_public_port" value="" size="10" maxlength="5" onKeyPress="return numbersonly(this)" <?=$disabled?> >
    	<br>
    	<font class="captionbig"><?=get_cm_var('setcfg_nat_private_ip')?></font>
        <input class="IPtextbox" type="text" name="NAT_port_ip1" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_port_ip2')" <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="NAT_port_ip2" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_port_ip3')" <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="NAT_port_ip3" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_port_ip4')" <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="NAT_port_ip4" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_port_ip1')" <?=$disabled?> >
    	<br>
        <font class="captionbig"><?=get_cm_var('setcfg_nat_private_port')?></font>
    	<input class="Porttextbox" type="text" name="NAT_private_port" value="" size="10" maxlength="5" onKeyPress="return numbersonly(this)" <?=$disabled?> >
    	<br>
    	<font class="captionbig"><?=get_cm_var('setcfg_nat_protocol')?></font>
    	<input type="checkbox" name="NAT_proto_tcp" value="tcp" <?=$disabled?> ><font class="normal"><?=get_cm_var('setcfg_nat_tcp')?></font>
    	<input type="checkbox" name="NAT_proto_udp" value="udp" <?=$disabled?> ><font class="normal"><?=get_cm_var('setcfg_nat_udp')?></font>
        <input type="button" value="<?=get_cm_var('setcfg_add_button')?>" title="<?=get_cm_var('setcfg_add_button')?>" class="graphicBtn" style="margin-left: 15px;" onclick="return addPortMap();" <?=$disabled?> >
    </td>
    </tr>
    </table>
    <br>
    </td>

</tr>

<!-- end of NAT -->
<tr><td width="100%" colspan="9">
<p style="margin-top: 1px; margin-bottom: 1px"><img src="./images/hline-sep-green.gif" width="100%" height="1"></p>
</td></tr>

<!-- ProxyARP Header -->
<tr id="proxyARP">
    <td width="400"><p class="indented">
        <img src="./images/smallbubble.gif" width="8" height="8">
        <img src="./images/blank.gif" width="10" height="6"><?=$version_star.get_cm_var('setcfg_proxyARP_PROXYARP')?>
    </td>
    <td width="50"><img src="./images/blank.gif" width="3" height="3"></td>
    <td width="300" class="normal">
    <input type="radio" name="proxyARP_enabled" value="1" onclick="showProxyARP(this)"  <?=$disabled?> <?=$eProxyARP_checked?> <?=($NAT_enabled==1)?"disabled":""?> ><?=get_cm_var('setcfg_proxyARP_enabled')?>
    <input type="radio" name="proxyARP_enabled" value="0" onclick="showProxyARP(this)"  <?=$disabled?> <?=$dProxyARP_checked?> <?=($NAT_enabled==1)?"disabled":""?> ><?=get_cm_var('setcfg_proxyARP_disabled')?>
    </td>
</tr>

<tr><td width="100%" colspan="9">
<p style="margin-top: 1px; margin-bottom: 1px"><img src="./images/hline-sep-green.gif" width="100%" height="1"></p>
</td></tr>

<!-- Proxy ARP Body -->
<tr id="proxyARP_table" align="center" style="display: <?=($ProxyARP_enabled>0)?'':'none'?>;">
    <td width="100%" colspan="4" align="center">    
    <br>
    <table>
    <tr>
    <td style="font-size: 0.9em;">
        <?=get_cm_var('setcfg_select_label')?>&nbsp;
        <a href="" title="<?=get_cm_var('setcfg_selectAll_desc')?>" onclick="return selectAll(self.frames.frameProxyARP.document.getElementsByName('entry'));"><font size="2" color="blue"><?=get_cm_var('setcfg_selectAll_button')?></font></a>&nbsp;
        <a href="" title="<?=get_cm_var('setcfg_selectClear_desc')?>" onclick="return selectClear(self.frames.frameProxyARP.document.getElementsByName('entry'));"><font size="2" color="blue"><?=get_cm_var('setcfg_selectClear_button')?></font></a>&nbsp;
        <input type="button" value="<?=get_cm_var('setcfg_delete_button')?>" title="<?=get_cm_var('setcfg_delete_button')?>" class="graphicBtn" onclick="deleteEntryProxyARP()"  <?=$disabled?> >&nbsp;&nbsp;<font id="ProxyARPdeleteTxt" size="3" color="red" style="display: none"><?=get_cm_var('setcfg_confirm_delete_txt')?></font>
    </td>
    </tr>
    
    <tr>
    <td>
    <iframe id="frameProxyARP" name="frameProxyARP" class="bordered_frame" frameborder="0" width="400" height="206" src="frameProxyARP.php" marginwidth="0" marginheight="0"></iframe>
    </td>
    
    <!--<p><form action="" name="formProxyARP" method="post" onSubmit="return addEntryProxyARP(this)" align="left">-->
    <td valign="bottom">
        <font class="captionbig"><?=get_cm_var('setcfg_proxyARP_IPRange_start')?></font>
        <input class="IPtextbox" type="text" name="ProxyARP_start_ip1" maxlength="3" onKeyPress="return numbersonly(this,event,'ProxyARP_start_ip2')"  <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="ProxyARP_start_ip2" maxlength="3" onKeyPress="return numbersonly(this,event,'ProxyARP_start_ip3')"  <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="ProxyARP_start_ip3" maxlength="3" onKeyPress="return numbersonly(this,event,'ProxyARP_start_ip4')" <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="ProxyARP_start_ip4" maxlength="3" onKeyPress="return numbersonly(this,event,'ProxyARP_start_ip1')" <?=$disabled?> >
        <br><font class="captionbig"><?=get_cm_var('setcfg_proxyARP_IPRange_end')?></font>
        <input class="IPtextbox" type="text" name="ProxyARP_end_ip1" maxlength="3" onKeyPress="return numbersonly(this,event,'ProxyARP_end_ip2')" <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="ProxyARP_end_ip2" maxlength="3" onKeyPress="return numbersonly(this,event,'ProxyARP_end_ip3')" <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="ProxyARP_end_ip3" maxlength="3" onKeyPress="return numbersonly(this,event,'ProxyARP_end_ip4')" <?=$disabled?> >.
        <input class="IPtextbox" type="text" name="ProxyARP_end_ip4" maxlength="3" onKeyPress="return numbersonly(this,event,'ProxyARP_end_ip1')" <?=$disabled?> >
        <input type="button" value="<?=get_cm_var('setcfg_add_button')?>" title="<?=get_cm_var('setcfg_add_button')?>" class="graphicBtn" style="margin-left: 15px;" onclick="addEntryProxyARP()"  <?=$disabled?> >
    </td>
    </tr>
    </table>
    <br>
    
    </td>
</tr>
<!-- end of ProxyARP -->

<!-- Save & Cancel -->
<tr>
<td width="100%" colspan="9" valign="top">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
    <tr valign="middle">
        <td width="50%" style="text-align: right">
            <input type="hidden" name="c_Nat_save" value="false">
            <input type="image" name="save_button" alt="Save" id="save_button" src="./images/save.gif" align="top" onclick="document.c_Nat.c_Nat_save.value='true';">
        </td>
        <td width="20"><img src="./images/blank.gif" align="top" width="20" height="50"></td>
        <td width="50%" style="text-align: left;">
            <input type="hidden" name="c_Nat_cancel" value="false">
            <input type="image" src="./images/cancel.gif" alt="Cancel" align="top" onclick="document.c_Nat.c_Nat_cancel.value='true';">
        </td>
    </tr>
    </table>
</td>
</tr>
<!-- End Save & Cancel -->
</form>
