<?php
    // security check
    require_once "secureLogin.php";
    require_once "cmvar.php";

	// 20090518 - Remove Start, add Premium
	// version control
	if (substr_count(strtolower($version), 'premium') > 0  || substr_count(strtolower($version), 'standard') > 0) {
        if (substr_count(strtolower($version),'donation')>0)
            $version = substr($version,0,strlen($version)-9);
        $disabled = ' disabled';
        $version_msg = '* This feature is not available in '. ucwords($version) .' Edition.';
        $version_star = '<span class="star">* </span>';
    } else {
        $disabled = '';
        $version_msg = '';
        $version_star = '';
    }

    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('setcfg.php FSCONFIG.Cfgmgr Object cannot be created!');

    if( !isset($FOMode) )
        $FOMode=$settingobj->getKey('mode', 'FSFO');

    if( $FOMode == '' )
        $FOMode = 0;
    
   $MainFirstSpotIP = $settingobj->getKey('Main_IP', 'FSFO');
	if( $MainFirstSpotIP=='' ){
    	$MFSIP[0] = '';
    	$MFSIP[1] = '';
    	$MFSIP[2] = '';
    	$MFSIP[3] = '';
	}else{
		$MFSIP = split("\.", $MainFirstSpotIP);
	}
		
  $MainFirstSpotNIC = $settingobj->getKey('Main_NIC', 'FSFO');
	if( $MainFirstSpotNIC=='' ){
		  $MFSNIC[0] = '';
    	$MFSNIC[1] = '';
    	$MFSNIC[2] = '';
    	$MFSNIC[3] = '';
	}else{
		$MFSNIC = split("\.", $MainFirstSpotNIC);
	 }
	
	$BackUpFirstSpotIP = $settingobj->getKey('BackUp_IP', 'FSFO');
	if( $BackUpFirstSpotIP=='' ){
    	$BUFSIP[0] = '';
    	$BUFSIP[1] = '';
    	$BUFSIP[2] = '';
    	$BUFSIP[3] = '';
	}else{
    	$BUFSIP = split("\.", $BackUpFirstSpotIP);
	}
	
	$BackUpFirstSpotNIC = $settingobj->getKey('BackUp_NIC', 'FSFO');
	if( $BackUpFirstSpotNIC=='' ){
    	$BUFSNIC[0] = '';
    	$BUFSNIC[1] = '';
    	$BUFSNIC[2] = '';
    	$BUFSNIC[3] = '';
	}else{
    	$BUFSNIC = split("\.", $BackUpFirstSpotNIC);
	}
    	
    if( !isset($FOBackupMode) )
        $FOBackupMode=$settingobj->getKey('BackupMode', 'FSFO');

    if( $FOBackupMode == '' )
        $FOBackupMode = 2;
        
	// Load Balancing 
	$OtherLBFirstSpotIP = $settingobj->getKey('OtherLB_IP', 'FSFO');
	if( $OtherLBFirstSpotIP=='' ){
    	$OLBFSIP[0] = '';
    	$OLBFSIP[1] = '';
    	$OLBFSIP[2] = '';
    	$OLBFSIP[3] = '';
	}else{
		$OLBFSIP = split("\.", $OtherLBFirstSpotIP);
	}
		
	$OtherLBFirstSpotNIC = $settingobj->getKey('OtherLB_NIC', 'FSFO');
	if( $OtherLBFirstSpotNIC=='' ){
		$OLBFSNIC[0] = '';
    	$OLBFSNIC[1] = '';
    	$OLBFSNIC[2] = '';
    	$OLBFSNIC[3] = '';
	}else{
		$OLBFSNIC = split("\.", $OtherLBFirstSpotNIC);
	 }
	
	$currMachineID=$settingobj->getKey('MachineID', 'FSFO');
    
    $FSFO_Port = $settingobj->getKey('Port', 'FSFO');
	$FSFO_Interval = $settingobj->getKey('interval', 'FSFO');
	if( $FSFO_Interval!='' )
		$FSFO_Interval = $FSFO_Interval/1000;
		
	$scenario2=$settingobj->getKey('scenario2', 'gateway');

    if( $FOMode == 0 ){
    	$defaultDisplay = 'none'; // Main Machine
    	$defaultDisplay1 = 'none'; // Backup Machine
    	$defaultDisplay2 = 'none'; // common eg. port, HeartBeat Interval 
    	$defaultDisplay3 = 'none'; // Load balancing
    	$backupModeDisplay = 'none'; // eg. Back Mode
	}else if( $FOMode == 1){ // Main Machine
    	$defaultDisplay = '';
    	$defaultDisplay1 = 'none';
    	$defaultDisplay2 = '';
    	$defaultDisplay3 = 'none'; // Load balancing
    	$backupModeDisplay = 'none';
	}else if( $FOMode == 2 ){ // Backup Machine
    	$defaultDisplay = 'none';
    	$defaultDisplay1 = '';
    	$defaultDisplay2 = '';
    	$defaultDisplay3 = 'none'; // Load balancing
    	$backupModeDisplay = '';    	
	}else if($FOMode == 3){ // using Load Balancing
		$defaultDisplay = 'none';
    	$defaultDisplay1 = 'none';
    	$defaultDisplay2 = '';
    	$defaultDisplay3 = ''; // Load balancing
    	$backupModeDisplay = 'none';
	}
	
    $settingobj=null;
?>
<script type="text/javascript" src="./javascript/FO.js"></script>

<form name="c_FO" action="settingok.php" method="post" onSubmit="return validate_fo()">
<!-- FailOver Header -->
<?
    gen_license_warning($version_msg);

    // Mode Selection
    // Load Balancing not allow enable Scenario2 
    $input=
    '<input type="radio" name="fo_mode" value="0" '.($FOMode==0? "checked" : "").' onClick="switchFOMode(this)">'.get_cm_var('setcfg_failover_mode0').
    '<br><input type="radio" '. $disabled .' name="fo_mode" value="1" '.($FOMode==1? "checked" : "").' onClick="switchFOMode(this)">'.get_cm_var('setcfg_failover_mode1').
    '<br><input type="radio" '. $disabled .' name="fo_mode" value="2" '.($FOMode==2? "checked" : "").' onClick="switchFOMode(this)">'.get_cm_var('setcfg_failover_mode2').
    '<br><input type="radio" '. $disabled .' name="fo_mode" value="3" '.($FOMode==3? "checked" : "").' onclick="if (document.c_FO.fo_mode[3].checked && '.$scenario2.' == 1) {alert(\''.get_cm_var('js_alert_failover_15').'\'); return false;}else switchFOMode(this);">'.get_cm_var('setcfg_failover_mode3').
    '<br>';
    
    gen_line($version_star.get_cm_var('setcfg_failover_mode'),$input);

    gen_invisible_sep( 'sep1', $defaultDisplay1 );

    // Main Machine IP
    $input=
    '<input class="IPtextbox" type="text" '.$disabled.' name="MainFSIP1" maxlength="3" value="'.$MFSIP[0].'" onKeyPress="return iponly(this,event,\'MainFSIP2\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="MainFSIP2" maxlength="3" value="'.$MFSIP[1].'" onKeyPress="return iponly(this,event,\'MainFSIP3\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="MainFSIP3" maxlength="3" value="'.$MFSIP[2].'" onKeyPress="return iponly(this,event,\'MainFSIP4\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="MainFSIP4" maxlength="3" value="'.$MFSIP[3].'" onKeyPress="return iponly(this,event)" onfocus="this.select()">';
    gen_invisible_line($version_star.get_cm_var('setcfg_failover_MainIP'),$input,'MainMachineIP',$defaultDisplay1);

    gen_invisible_sep( 'sep1a', $defaultDisplay1 );
    
    // Main Machine Private NIC IP
    $input=
    '<input class="IPtextbox" type="text" '.$disabled.' name="MainFSNIC1" maxlength="3" value="'.$MFSNIC[0].'" onKeyPress="return iponly(this,event,\'MainFSNIC2\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="MainFSNIC2" maxlength="3" value="'.$MFSNIC[1].'" onKeyPress="return iponly(this,event,\'MainFSNIC3\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="MainFSNIC3" maxlength="3" value="'.$MFSNIC[2].'" onKeyPress="return iponly(this,event,\'MainFSNIC4\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="MainFSNIC4" maxlength="3" value="'.$MFSNIC[3].'" onKeyPress="return iponly(this,event)" onfocus="this.select()">';
    gen_invisible_line($version_star.get_cm_var('setcfg_failover_MainNIC'),$input,'MainMachineNIC',$defaultDisplay1);
    
    gen_invisible_sep( 'sep2', $defaultDisplay);
    
    // BackUp Machine IP
    $input=
    '<input class="IPtextbox" type="text" '.$disabled.' name="BackUpFSIP1" maxlength="3" value="'.$BUFSIP[0].'" onKeyPress="return iponly(this,event,\'BackUpFSIP2\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="BackUpFSIP2" maxlength="3" value="'.$BUFSIP[1].'" onKeyPress="return iponly(this,event,\'BackUpFSIP3\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="BackUpFSIP3" maxlength="3" value="'.$BUFSIP[2].'" onKeyPress="return iponly(this,event,\'BackUpFSIP4\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="BackUpFSIP4" maxlength="3" value="'.$BUFSIP[3].'" onKeyPress="return iponly(this,event)" onfocus="this.select()">';
    gen_invisible_line($version_star.get_cm_var('setcfg_failover_BackIP'),$input,'BackUpMachineIP',$defaultDisplay);

    gen_invisible_sep( 'sep3', $defaultDisplay );

    // BackUp Machine Private NIC IP
    $input=
    '<input class="IPtextbox" type="text" '.$disabled.' name="BackUpFSNIC1" maxlength="3" value="'.$BUFSNIC[0].'" onKeyPress="return iponly(this,event,\'BackUpFSNIC2\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="BackUpFSNIC2" maxlength="3" value="'.$BUFSNIC[1].'" onKeyPress="return iponly(this,event,\'BackUpFSNIC3\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="BackUpFSNIC3" maxlength="3" value="'.$BUFSNIC[2].'" onKeyPress="return iponly(this,event,\'BackUpFSNIC4\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="BackUpFSNIC4" maxlength="3" value="'.$BUFSNIC[3].'" onKeyPress="return iponly(this,event)" onfocus="this.select()">';
    gen_invisible_line($version_star.get_cm_var('setcfg_failover_BackNIC'),$input,'BackUpMachineNIC',$defaultDisplay);
    
    // Other Load Balancing Machine
    gen_invisible_sep( 'sep7', $defaultDisplay3 );

    // Other Load Balancing Machine IP
    $input=
    '<input class="IPtextbox" type="text" '.$disabled.' name="OtherLBFSIP1" maxlength="3" value="'.$OLBFSIP[0].'" onKeyPress="return iponly(this,event,\'OtherLBFSIP2\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="OtherLBFSIP2" maxlength="3" value="'.$OLBFSIP[1].'" onKeyPress="return iponly(this,event,\'OtherLBFSIP3\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="OtherLBFSIP3" maxlength="3" value="'.$OLBFSIP[2].'" onKeyPress="return iponly(this,event,\'OtherLBFSIP4\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="OtherLBFSIP4" maxlength="3" value="'.$OLBFSIP[3].'" onKeyPress="return iponly(this,event)" onfocus="this.select()">';
    gen_invisible_line($version_star.get_cm_var('setcfg_failover_OtherLBIP'),$input,'OtherLBMachineIP',$defaultDisplay3);

    gen_invisible_sep( 'sep7a', $defaultDisplay3 );
    
    // Other Load Balancing Machine Private NIC IP
    $input=
    '<input class="IPtextbox" type="text" '.$disabled.' name="OtherLBFSNIC1" maxlength="3" value="'.$OLBFSNIC[0].'" onKeyPress="return iponly(this,event,\'OtherLBFSNIC2\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="OtherLBFSNIC2" maxlength="3" value="'.$OLBFSNIC[1].'" onKeyPress="return iponly(this,event,\'OtherLBFSNIC3\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="OtherLBFSNIC3" maxlength="3" value="'.$OLBFSNIC[2].'" onKeyPress="return iponly(this,event,\'OtherLBFSNIC4\')" onfocus="this.select()">.'.
    '<input class="IPtextbox" type="text" '.$disabled.' name="OtherLBFSNIC4" maxlength="3" value="'.$OLBFSNIC[3].'" onKeyPress="return iponly(this,event)" onfocus="this.select()">';
    gen_invisible_line($version_star.get_cm_var('setcfg_failover_OtherLBNIC'),$input,'OtherLBMachineNIC',$defaultDisplay3);
    
    gen_invisible_sep( 'sep7b', $defaultDisplay3 );
    
    // Similar c_Auth.php Scenario2 part
    //create machineID listbox
    $input='<select name="machineID" style="width:180px; font-family: sans-serif, Tahoma; font-size:9pt;">';
    $input .= '<option value="">No selected MachineID</option>';
    
    $count=1;
    while ($count <=50) {
        if ($count < 10)
            $zeroStr="0";
        else
            $zeroStr="";
        $machineID="Machine".$zeroStr.$count;
        $selectedSite="";
         if ($currMachineID == $machineID) $selectedSite="selected";
        $input .= "<option value=\"$machineID\" $selectedSite>$machineID</option>";
        $count++;
    }

    $input .= "</select>";

    gen_invisible_line(get_cm_var('setcfg_failover_machineID'), $input, 'machineID', $defaultDisplay3);
    
    gen_invisible_sep( 'sep7d', $defaultDisplay3 );
	
    // clear message checkbox
    $input = '<input type="checkbox" '.$disabled.' name="clearMessage" value="true" onclick="if (document.c_FO.clearMessage.checked) alert(\''.get_cm_var('setcfg_auth_clear_message_table_remind').'\')">'.get_cm_var('setcfg_auth_clear_message_table');
    
    gen_invisible_line(get_cm_var('setcfg_failover_clear_message'), $input, 'clear_Message_table', $defaultDisplay3);
    
    gen_invisible_sep( 'sep7e', $defaultDisplay3 );
    
    //--------------
    
    // BackupMode Selection
    $input=
    '<input type="radio" '.$disabled.' name="fo_BackupMode" value="1" '.($FOBackupMode==1? "checked" : "").' >'.get_cm_var('setcfg_failover_BackupMode1').
    '<br><input type="radio" '. $disabled .' name="fo_BackupMode" value="2" '.($FOBackupMode==2? "checked" : "").' >'.get_cm_var('setcfg_failover_BackupMode2').
    '<br><input type="radio" '. $disabled .' name="fo_BackupMode" value="3" '.($FOBackupMode==3? "checked" : "").' >'.get_cm_var('setcfg_failover_BackupMode3').
    '<br>';
    gen_invisible_line($version_star.get_cm_var('setcfg_failover_BackupMode'),$input,'BackupMode',$backupModeDisplay);
    
    gen_invisible_sep( 'sep5', $backupModeDisplay );

    $input='<input class="shorttextbox" type="text" '.$disabled.' name="port" maxlength="5" value="'.$FSFO_Port.'" onKeyPress="return portonly(this,event)" onfocus="this.select()">(Blank=5794)';
    gen_invisible_line($version_star.get_cm_var('setcfg_failover_Port'), $input, 'FSFOPort', $defaultDisplay2);

    gen_invisible_sep( 'sep6', $defaultDisplay2 );

    $input='<input class="shorttextbox" type="text" '.$disabled.' name="interval" maxlength="5" value="'.$FSFO_Interval.'" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">(Blank=5 second)';
    gen_invisible_line($version_star.get_cm_var('setcfg_failover_Interval'), $input, 'FSFOInterval', $defaultDisplay2);

    gen_sep();

    /*gen_save2('c_FO','c_FO_save','c_FO_cancel');*/
    gen_save('save_fo',$fs_status);
?>
</form>
