<?php

// Disable caching of the current document:
header('Cache-Control: no-cache, no-store, max-age=0, must-revalidate');
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
header('Pragma: no-cache');

require_once 'common_functions.php';
require_once "fs_lang.php";

$j_common="";

$settingobj = new COM('FSCONFIG.Cfgmgr') or die('ibmsgScript.php FSCONFIG.Cfgmgr Object cannot be created!');
$ip_address = $settingobj->getKey( "gateway_IP", "gateway");
$session_handling = $settingobj->getKey( "session_handling", "gateway");

// scenario2 and load balancing
$isScenario2 = $settingobj->getKey('scenario2', 'gateway');
$FOMode=$settingobj->getKey('mode', 'FSFO');
$curr_ID="";

$enableLoadBalancing=0;
if($FOMode == 3){
	$enableLoadBalancing=1;
	$curr_ID = $settingobj->getKey('MachineID', 'FSFO');
}
else if ($isScenario2){
	$curr_ID = $settingobj->getKey('siteID', 'gateway');
}

$conditionSiteID="";

// * siteID must match during using scenario2 or load balancing
if ($isScenario2 || $enableLoadBalancing)
	$conditionSiteID=" siteID ='".$curr_ID."' ";
else
	$conditionSiteID=" siteID is NULL or siteID ='' ";
	
$enableFailover=0;
$condMsgSiteID=""; // format siteID_XXXMachine
$msgSiteID="";
if ($FOMode == 1 || $FOMode == 2){
	$enableFailover=1;
	if ($isScenario2)
		$msgSiteID = $curr_ID."_";
		
	if ($FOMode == 1)
		$msgSiteID .= "MainMachine";
	else if ($FOMode == 2)
		$msgSiteID .= "BackupMachine";
		
	$condMsgSiteID=" siteID ='".$msgSiteID."' ";
	
}

$use_radius = $settingobj->getKey( 'use_radius', 'radius');

// connect to database
if( strtolower($use_radius)== 'true' ) {
    $dsn_file = $settingobj->getKey( 'Datasource', 'radius');
}else{
	$dsn_file = $settingobj->getKey( 'Datasource', 'gateway');
}

$dsn_source = fopen($dsn_file, 'r') or die('Cannot open DSN source file!');  
$dsn='';

if(!feof($dsn_source)) 
    $line=fgets($dsn_source,512); 

while(!feof($dsn_source)) {
    $line=fgets($dsn_source,512);
    if (trim($line)!='') $dsn.=$line;
}

$dsn=str_replace("\r\n",';',$dsn);

// Determine show IP or domain name
$showDomainUrl = $settingobj->getKey("show_domain_URL", "gateway");
//* using HTTP only
if (isset($showDomainUrl) && $showDomainUrl > 0) {
    // $urlhead = fs_local_domain_url();
	$versionType = $settingobj->getKey('version', 'version');
	if (substr_count(strtolower($versionType), 'start') > 0 || substr_count(strtolower($versionType), 'standard') > 0) {
		$dn = 'firstspot.org';
	} else {
		$dn = $settingobj->getKey("gateway_domain", "gateway");
		if ($dn == '') {
			$dn = 'firstspot.org';
		}
	}
	$head="http://";
	$urlhead = $head.$dn;
} else {
    // $urlhead = fs_local_ip_url();
	$ip_address = $settingobj->getKey( "gateway_IP", "gateway");
	$head="http://";
	$urlhead = $head.$ip_address;
}

// new for commercial break
$iB_cb_redirect = $settingobj->getKey("iB_cb_redirect", "IB");
$iB_redirect_option = $settingobj->getKey("iB_redirect_option", "IB");
$iB_redirect_wait = $settingobj->getKey("iB_redirect_wait", "IB");
$iB_redirect_showLink = $settingobj->getKey("iB_redirect_showLink", "IB");
$iB_redirect_showLink_wait = $settingobj->getKey("iB_redirect_showLink_wait", "IB");

$redirect_option=0; // 0=do not redirect, 1=redirect delay
if ($iB_redirect_option !=""){
	$redirect_option=$iB_redirect_option;
}
$redirect_wait_time=0;
if ($iB_redirect_wait !=""){
	$redirect_wait_time=$iB_redirect_wait;
}
$showLink_option=0;
$showLink_wait_time=0;

if ($iB_redirect_showLink !=""){
	$showLink_option=$iB_redirect_showLink;
	if ($iB_redirect_showLink == 2){
		if ($iB_redirect_showLink_wait !=""){
			$showLink_wait_time=$iB_redirect_showLink_wait * 1000;
		}
	}
}

$settingobj=null;

// checking this page call from fsRedirector (match private ip and server name)
if(isset($_SERVER['REMOTE_ADDR']) && $_SERVER['REMOTE_ADDR'] == $ip_address && isset($_SERVER['HTTP_SERVER']) && $_SERVER['HTTP_SERVER'] == "FirstSpotDispatcher"){
	if (isset($_GET['request']) && $_GET['request'] != "none" && isset($_GET['patronsoft1']) &&  isset($_GET['patronsoft2'])){
		$userDB=odbc_connect($dsn,'','');
		
		$reserved1="";
		$q="";
		
		$macOrIp_str="";
		$userStr="";
		
		if ($session_handling == 1){
			$reserved1=$_GET['patronsoft1'];
			$macOrIp_str=long2ip($reserved1);
			$ip = explode(".",$macOrIp_str);
			$macOrIp_str=$ip[3].".".$ip[2].".".$ip[1].".".$ip[0];
		}else{
			$reserved1=$_GET['patronsoft2'];
			$macOrIp_str=make_mac_name($reserved1);
		}
		
		$q = 'select * from '.fs_usr_table()." where reserved1 = '".$reserved1."' and (".$conditionSiteID.");";

		$result = odbc_exec( $userDB, $q );
		$username = odbc_result( $result, 'name' );
		
		odbc_free_result( $result );
		
		if ($username != ""){
		
			// create a COM object
			$myobj = new COM('FSAUTH.Authserv') or die('cb_redirect.php FSAUTH.Authserv object cannot be created!');
			$myobj->CancelIBMsgByCB($reserved1);
			$myobj=null;
			
			// hard code (using another file to redirect, prevent loop by cache)
			$redirect_desturl=$urlhead."/redirect_page.php?r_url=".$_GET['url'];
			
			$input = "
			<div id=\"cb_r_link\" style=\"visibility:hidden; display:none;\">
				<table width=\"100%\" border=\"0\" cellpadding=\"20\" valign=\"top\">
					<tr>
						<td align=\"center\">
						<span class=\"redirectspan\">".get_var('cb_redirect_msg1')." <a href='".$redirect_desturl."' onmouseover=\"window.status='';return true;\"onmouseout=\"window.status='';\"><span class=\"redirectaddr\">".get_var('cb_redirect_msg2_link')."</span></a> ".get_var('cb_redirect_msg3')."<span id=\"displayWaitTime\"></span></span>
						</td>
					</tr>
				</table>
			</div>
			";
			
			// web site
			// $iframe_url="http://www.patronsoft.com";
			// local content
			$iframe_url=$urlhead."/cb_frame.php";
			
			// apply in <head> tag for apply iframe to 100% height in FireFox 
			$j_common.='
				<style type="text/css">
					html, body { height:100%; }
				</style>
			';
			
			$smarty = new SmartyConnect;
			$smarty->assign('L_REDIRECT_CHARSET', metaCharset());
			$smarty->assign('L_REDIRECT_TITLE', get_var('cb_redirect_title'));
			$smarty->assign('REDIRECT_DESTURL', $redirect_desturl);
			$smarty->assign('L_REDIRECT_IFRAMEURL', $iframe_url);
			$smarty->assign('J_REDIRECT_ACCESS_DIRECTLY', $redirect_option);
			$smarty->assign('J_REDIRECT_WAIT_TIME', $redirect_wait_time);
			$smarty->assign('L_REDIRECT_INPUT', $input);
			$smarty->assign('J_COMMON', $j_common);
			
			$smarty->assign('J_REDIRECT_SHOW_LINK', $showLink_option);
			$smarty->assign('J_SHOW_LINK_WAIT_TIME', $showLink_wait_time);
			
			$smarty->display('cb_redirect_body.tpl');
		}
	}
}
		