/** Need some function on validate.js (use this javascript must require 'validate.js' first )
*   isEmpty(strng), isDate(dtStr, dtTime), isTime(timeStr), DaysArray(n), stripCharsInBag(s, bag), daysInFebruary (year), isInteger(s)
**/

function init() {
/**
 *	Assign event to different element, hide sublist item,
 *	hide password type element, disabe save and cancel button,
 *	generate options in secretList.
 *
 *	@param none
 */
	setEvent();
	hideNestedList();
	showPasswordItem('none'); //hide password type elements
	document.getElementById('save').disabled = true;
	document.getElementById('cancel').disabled = true;
	refreshGroupList();
}
function refreshGroupList() {
/**
 *	make sure the list of group in secretList is up-to-date
 *	and reflect what is in array glo_arrGroup[].
 *
 *	@param none
 */
	var oldSelectedIndex;
	var listObj = document.getElementById('secretList');
	with (listObj) {
		oldSelectedIndex = selectedIndex;
		//clear all item first
		if (glo_arrGroup.length < length/2) {
			innerHTML = "";
			length = glo_arrGroup.length;
		} else if (glo_arrGroup.length != length) {
			length = glo_arrGroup.length;
		}
		//restore value to the list
		for (var i in glo_arrGroup) {
			options[i].text = glo_arrGroup[i][0];
		}
		if (oldSelectedIndex >= 0 && oldSelectedIndex < length) {
			selectedIndex = oldSelectedIndex;
		}
	} //end with list object
}

function addGroup(gpName) {
/**
 *	Add an entry into global variable glo_arrGroup[].
 *	The entries in glo_arrGroup[] will remain in alphabetical
 *	order.
 *
 *	@para gpName the gpName of the new group
 */
	var i, j;
	//find where to add
	for (i=0; i<glo_arrGroup.length; i++) {
		if (glo_arrGroup[i][0] > gpName) {
			break;
		}
	}
	//shifting array elements forward by one
	for (j=glo_arrGroup.length; j>i; j--) {
		glo_arrGroup[j] = glo_arrGroup[j-1];
	}
	//add to array
	glo_arrGroup[i] = [gpName,''];
}

function removeGroup(gpString) {
/**
 *	Remove all group, whose name appear in gpString,
 *	from array glo_arrGroup[].
 *
 *	@param gpString string contain different groupname joined together by comma
 */
	//gpString must be in alphabetical order
	var arrGroupToRemove = gpString.split(',');
	var i=0, j=0, k=0;
	while (i < glo_arrGroup.length) {
		if (j<arrGroupToRemove.length && glo_arrGroup[i][0]==arrGroupToRemove[j]) {
			//skip the current group, look for next group	
			i++;	
			j++;
		} else {
			//store current group to next position in glo_arrGroup
			glo_arrGroup[k] = glo_arrGroup[i];
			//look for next group
			i++;
			k++;
		}
	}
	glo_arrGroup = glo_arrGroup.slice(0,k);
}
function hideNestedList() {
/**
 *	Hide all LI items that is below second level.
 *	Disabled all INPUT items that is inside the LI items being hided.	
 *
 *	@param none
 */
	var arrULElement = document.getElementById('level1').getElementsByTagName('UL'); //find second lever UL elements
	for (var i=0; i < arrULElement.length; i++) {
		var arrLIElement = arrULElement[i].getElementsByTagName('LI');
		for (var j=0; j<arrLIElement.length; j++) {
			arrLIElement[j].style.display = 'none';
			var arrINPUTElement = arrLIElement[j].getElementsByTagName('INPUT');
			for (var k=0; k<arrINPUTElement.length; k++) {
				//arrINPUTElement[k].disabled = true;
				arrINPUTElement[k].disabled = !arrINPUTElement[k].readOnly;
			}
		}
	}
}
function textFieldOnfocus(evt) {
    var objToSelect = getEventElement(evt);
    objToSelect.select();
}
function setEvent() {
/**
 *	Assign different function to different elements in the page
 *
 *	@param none;
 */
	var i;
	var arrElement = document.forms.frmSecret.getElementsByTagName("SELECT");
	for (i=0; i < arrElement.length; i++) {
		arrElement[i].onchange = adjustDisplay;
	}
	var arrElement = document.forms.frmSecret.getElementsByTagName("INPUT");
	//make all text field selected onfocus
	for (i=0; i < arrElement.length; i++) {
		if (arrElement[i].type=="password" || arrElement[i].type=="text") {
			arrElement[i].onfocus = textFieldOnfocus;
		}
	}
	document.getElementById('add').onclick = addSecret;
	document.getElementById('edit').onclick = editSecret;
	document.getElementById('view').onclick = cancel;
	document.getElementById('delete').onclick = deleteGroup;
	document.getElementById('save').onclick = saveOnclick;
	document.getElementById('cancel').onclick = cancel;
	document.getElementById('refresh').onclick = refreshPage;
	document.getElementById('resetDtcBtn').onclick = resetGroup;
	document.getElementById('exportGroup').onclick = exportGroup;
	document.getElementById('importGroup').onclick = importGroup;
	document.getElementById('secretList').onchange = lookupSecret;
}
function adjustDisplay() {
/**
 *	Hide all second level elments first. The show up and enable
 *	all the subelements of the options currently being selected.
 *
 *	@param none
 */
	hideNestedList(); //hide all second level UL element and its childs
	var arrElement = document.forms.frmSecret.getElementsByTagName("SELECT");
	var saveBtnStatus = document.getElementById('save').disabled;
	var mode = document.getElementById('save').getAttribute('mode');
	var objToShow;
	var subElementId; //list of id of LI element controlled by a SELECT element
	var arrINPUTElement;
	var arrSubElementId;
	var listObj = document.getElementById('secretList');
	if (listObj.selectedIndex >= 0) {
		var arrGroupDetail = glo_arrGroup[listObj.selectedIndex][1].split(',');
		var isOnline = arrGroupDetail[13]=="online";
	}

	//show all subelement first
	for (var i=0; i < arrElement.length; i++) {
		if (arrElement[i].selectedIndex >= 0) { //check if an option is selected
			subElementId = arrElement[i].options[arrElement[i].selectedIndex].getAttribute('subElement');
			if (subElementId) { //not all Selection box has subelement to control
				arrSubElementId = subElementId.split(','); //the subElement is a list separated by ','
				for (var j=0; j < arrSubElementId.length; j++) {
					objToShow = document.getElementById(arrSubElementId[j]);
					if (objToShow) { //check if the subelement is there
						setDisplay(objToShow, '');
						arrINPUTElement = objToShow.getElementsByTagName('INPUT');
						for (var k=0; k<arrINPUTElement.length; k++) {
							//do not disable readonly field since all applied style will not be shown in disabled stated
							arrINPUTElement[k].disabled = saveBtnStatus && !arrINPUTElement[k].readOnly; 
						} //end for each INPUT elements in subElement
					} //end if the subElement is there in document
				} //end for each subElements
			} //end if there is subElement
		} //end if an option is selected in  selection box
	} //end for each SELECT elements

	// 20080422 - Add data transfer sharing part
	//hide and disable some of the rows accourding to condition
	if (mode=="edit" && isOnline) {
		//only add qutoa is allow when the group is online
		setDisabled(document.forms.frmSecret.elements.dtcUL, true);
		setDisabled(document.forms.frmSecret.elements.dtcDL, true);
		setDisabled(document.forms.frmSecret.elements.dtcSha, true);
		setDisabled(document.forms.frmSecret.elements.quotaUL, true);
		setDisabled(document.forms.frmSecret.elements.quotaDL, true);
		setDisabled(document.forms.frmSecret.elements.quotaSha, true);
	} else {
		//in add mode, view mode and edit mode with group offline
		setDisplay(document.getElementById('dtcULAddQuota'), 'none');
		setDisplay(document.getElementById('dtcDLAddQuota'), 'none');
		setDisplay(document.getElementById('dtcShaAddQuota'), 'none');
		setDisabled(document.forms.frmSecret.elements.addQuotaUL, true);
		setDisabled(document.forms.frmSecret.elements.addQuotaDL, true);
		setDisabled(document.forms.frmSecret.elements.addQuotaSha, true);
		if (mode=="add") { //in add mode, no need to show usage
			setDisplay(document.getElementById('dtcULUsage'), 'none');
			setDisplay(document.getElementById('dtcDLUsage'), 'none');
			setDisplay(document.getElementById('dtcShaUsage'), 'none');
		}
	}
}
function setDisabled(obj, bool) {
	/**
	 *	This funtion ensure the obj is available before 
	 *	setting its attribute to prevent javascript error.
	 */
	if (obj) {
		obj.disabled = bool;
	}
}
function setDisplay(obj, displayString) {
	/**
	 *	This funtion ensure the obj is available before 
	 *	setting its attribute to prevent javascript error.
	 */
	if (obj) {
		obj.style.display = displayString;
	}
}
function setValue(obj, whatValue, storeValue) {
	/**
	 *	This funtion ensure the obj is available before 
	 *	setting its attribute to prevent javascript error.
	 */
	if (obj) {
		switch (whatValue) {
			case "value":
				obj.value = storeValue;
				break;
			case "selectedIndex":
				obj.selectedIndex = storeValue;
				break;
			case "className":
				obj.className = storeValue;
				break;
			default:
				break;
		}
	}
}
function validateFrmSecret() {
/**
 *	Check if secret form is entered correctly without error.
 *	
 *	@return ok boolean state whether all form field is correct.
 */
	var ok = true;
	// 20080422 - Add data transfer sharing part
	with (document.forms.frmSecret) {
		ok = ok && textFormat('gpName');
		ok = ok && pwFormat('secretCode');
		ok = ok && pwFormat('confirmSecretCode');
		ok = ok && intFormat('btDL');
		ok = ok && intFormat('btUL');
		ok = ok && intFormat('quotaDL');
		ok = ok && intFormat('quotaUL');
		ok = ok && intFormat('quotaSha');
		ok = ok && intFormat('resetDailyDay',true);
		ok = ok && dayFormat('resetMonthlyDay');
		ok = ok && intFormat('resetMonthlyMonth',true);
		ok = ok && intFormat('resetDailyDay');
		ok = ok && pwMatch('secretCode','confirmSecretCode');
		ok = ok && timeFormat('monthlyResetLastabwDate','monthlyResetLastabwTime');
		ok = ok && dateFormat('monthlyResetLastabwDate','monthlyResetLastabwTime');
		ok = ok && timeFormat('dailyResetLastabwDate','dailyResetLastabwTime');
		ok = ok && dateFormat('dailyResetLastabwDate','dailyResetLastabwTime');
		ok = ok && warnMonthDate('resetMonthlyDay');
		ok = ok && NotifyEnableDtcTotal('dtcSha', 'dtcDL', 'quotaDL', 'dtcUL', 'quotaUL');
	}
	return ok;
}
function pwFormat(elementName) {
/*
 *	Check if there is any space in secret field and it is not empty.
 *
 *	@param elementName the name of the form element being validated.
 *	@return whether the field had space or is empty
 */
	var obj = document.forms.frmSecret.elements[elementName];
	var ok = true;
	if (obj) {
		if (!obj.disabled && obj.value!='     ' && (obj.value.match(/['"$^&\/\\\s<>]/) || obj.value.length < 1)) {
			ok = false;
			alert(glo_jsMessage.ssecret_js_alert_secret);
			obj.select();
		}
	}
	return ok;
}
function pwMatch(elementName1, elementName2) {
/**
 *	Check if the two secret text box is the same string.
 *
 *	@param elementNalme1 name of the first secret textbox
 *	@param elementNalme2 name of the second secret textbox
 *	@return              whether the two secret match
 */
	var obj1 = document.forms.frmSecret.elements[elementName1];
	var obj2 = document.forms.frmSecret.elements[elementName2];
	var ok = true;
	if (obj1 && obj2) {
		if (!obj1.disabled && !obj2.disabeld && obj1.value != obj2.value) {
			ok = false;
			alert(glo_jsMessage.ssecret_js_alert_secret_unmatch);
			obj1.select();
		}
	}
	return ok;
}
function textFormat(elementName) {
/**
 *	check if the field has space or is empty
 *	
 *	@param elementName name of the form elements to be checked
 *	@return            whether the field has space or is empty
 */
	var obj = document.forms.frmSecret.elements[elementName];
	var ok = true;
	if (obj) {
		//please add other forbidden symbol inside following square branket
		if (!obj.disabled && (obj.value.match(/['"$^&\/\\\s<>]/) || obj.value.length < 1)) {
			ok = false;
			alert(glo_jsMessage.ssecret_js_alert_gpname_nospace);
			obj.select();
		}
	}
	return ok;
}
function intFormat(elementName,checkzero) {
/**
 *	check if the field is a positive integer
 *	
 *	@param elementName name of the form elements to be checked
 *	@return            whether the field is a positive integer
 */
 
	var obj = document.forms.frmSecret.elements[elementName];
	var ok = true;
	if (obj) {
		var intValue = parseInt(obj.value);
		if (!obj.disabled && ((isNaN(intValue) || intValue < 0) || (checkzero == true && intValue ==0 )) ) {
			ok = false;
			alert(glo_jsMessage.ssecret_js_alert_integer);
			obj.select();
		} else {
			obj.value = intValue;
		}
	}
	return ok;
}
function dayFormat(elementName) {
/**
 *	check if the field is a positive integer between 1 and 31
 *	
 *	@param elementName name of the form elements to be checked
 *	@return            whether the field is valid
 */
	var obj = document.forms.frmSecret.elements[elementName];
	var ok = true;
	if (obj) {
		var intValue = parseInt(obj.value);
		if (!obj.disabled && (isNaN(intValue) || intValue < 1 || intValue > 31)) {
			ok = false;
			alert(glo_jsMessage.ssecret_js_alert_day);
			obj.select();
		} else {
			obj.value = intValue;
		}
	}
	return ok;
}
function addSecret() {
/**
 *	Switch to add group mode. By clearing, enabling all field and change
 *	the color of right panel
 *
 *	@param none
 */
	document.getElementById('save').setAttribute('mode', 'add');
	disableAll(false);
	clearFormField('frmSecret');
	document.forms.frmSecret.elements.secretCode.value = '';
	document.forms.frmSecret.elements.confirmSecretCode.value = '';
	showPasswordItem('');
	disableElement('add', true);
	disableElement('edit', false);
	disableElement('view', false);
	disableElement('delete', true);
	disableElement('save', false);
	disableElement('cancel', false);
	document.getElementById('rightPanel').className = 'rightPanelAdd';
	document.getElementById('rightPanelFooter').className = 'rightPanelFooterAdd';
	adjustDisplay();
	document.forms.frmSecret.elements.gpName.select();
}
function editSecret() {
/**
 *	Switch to edit group mode. By enabling all fields and change
 *	color of right panel
 */
	var obj = document.getElementById('secretList');
	var numOfSelectedItem = 0;
	var i = 0;
	//check if only one group is selected
	with (obj) {
		while (i<length && numOfSelectedItem<2) {
			if (options[i].selected) {
				numOfSelectedItem++;
			}
			i++;
		}
	}	
	if (numOfSelectedItem==1) { //only allow edit one group at a time
		document.getElementById('save').setAttribute('mode','edit');
		disableAll(false);
		showPasswordItem('');
		disableElement('add', false);
		disableElement('edit', true);
		disableElement('view', false);
		disableElement('delete', true);
		disableElement('save', false);
		disableElement('cancel', false);
		disableElement('gpName', true);
		document.getElementById('rightPanel').className = 'rightPanelEdit';
		document.getElementById('rightPanelFooter').className = 'rightPanelFooterEdit';
		//clear the old detail to force reload of details so that group's online status is up-to-date
		glo_arrGroup[obj.selectedIndex][1] = '';
		lookupSecret();
	} else {
		alert(glo_jsMessage.ssecret_js_alert_edit_nogroup);
	}
}
function cancel() {
/**
 *	Switch to view group mode. By disabling all fields and change
 *	color of the right panel
 */
	document.getElementById('save').setAttribute('mode','');
	disableElement('add', false);
	disableElement('edit', false);
	disableElement('delete', false);
	disableElement('save', true);
	disableElement('cancel', true);
	disableAll(true);
	showPasswordItem('none'); //hide password type elements
	document.getElementById('rightPanel').className = 'rightPanelView';
	document.getElementById('rightPanelFooter').className = 'rightPanelFooterView';
	lookupSecret();
}
function disableElement(elementId, state) {
/**
 *	Disable or enable an element.
 *
 *	@param elementId the id of the element being disabled/enabled
 *	@param state 	 whether the element should be disabled/enabled
 */
	document.getElementById(elementId).disabled = state;
}
function disableAll(state) {
/**
 *	Disable/enable all elements in form name 'frmSecret'.
 *
 *	@param state whether the elements should be disabled/enabled
 */
	with (document.forms.frmSecret) {
		for (var i=0; i<elements.length; i++) {
			elements[i].disabled = state;
		}
	}
}
function clearFormField(formName) {
/**
 *	Clear all the field of a form.
 *
 *	@param formName name of the form to be cleared
 */
	var vv;
	with (document.forms[formName]) {
		for (var i=0; i<elements.length; i++) {
			switch (elements[i].type) { 
				case "text":
				case "password":
					vv = elements[i].getAttribute('dv');
					if (typeof(vv) != 'undefined') {
						elements[i].value = vv;
					} else {
						elements[i].value = '';
					}
					break;
				case "checkbox":
					elements[i].checked = false;
					break;
				case "select-one":
					elements[i].selectedIndex = 0;
					break;
			} //end switch
		} //end for each element in form
	} //end with form
}
function lookupSecret() {
/**
 *	Find out the detail of the group now being selected in selection
 *	box named 'secretList' from the database. By mean of remote
 *	scripting.
 */
	var listObj = document.getElementById('secretList');
	if (listObj.selectedIndex>=0) { //at least one item is selected
		if (glo_arrGroup[listObj.selectedIndex][1]=='') {
			var formHTML = "<form action=\"lookupGroup.php\" method=\"post\">";
			formHTML += "<input type=\"hidden\" name=\"gpName\" value=\"" + glo_arrGroup[listObj.selectedIndex][0] + "\">";
			formHTML += "</form>";
			makeRemoteRequest(formHTML);
		} else {
			showSecret();
		}
	}
}
function showSecret() {
/**
 *	Take information of currently selected group from the array 
 *	glo_arrGroup[] and display the information in the form named
 *	'frmSecret'
 *
 *	The array arrGroupDetail[]:
 *	0 - group name
 *	1 - bt mode
 *	2 - custom btUL
 *	3 - custom btDL
 *	4 - mode of download data transfer count
 *	5 - download consummed
 *	6 - download quota
 *	7 - mode of upload data transfer count
 *	8 - upload consummed 
 *	9 - upload quota
 *	10 - mode of counter reset
 *	11 - day of the month when counter will be reset
 *	12 - for how many day/month the counter will be reset
 *	13 - last period of time (Reset ABW)
 *	14 - mode of total data transfer count
 *	15 - total consummed
 *	16 - total quota
 */
	var listObj = document.getElementById('secretList');
	var arrGroupDetail = glo_arrGroup[listObj.selectedIndex][1].split(',');
	clearFormField('frmSecret');
	with (document.forms['frmSecret']) {
		gpName.value = arrGroupDetail[0];
		switch (arrGroupDetail[1]) { //bandwidth throttling
			case "global":
				elements.bt.selectedIndex = 0;
				break;
			case "no":
				elements.bt.selectedIndex = 1;
				break;
			case "low":
				elements.bt.selectedIndex = 2;
				break;
			case "medium":
				elements.bt.selectedIndex = 3;
				break;
			case "high":
				elements.bt.selectedIndex = 4;
				break;
			case "specify":
				elements.bt.selectedIndex = 5;
				setValue(elements.btUL, 'value', parseInt(arrGroupDetail[2]));
				setValue(elements.btDL, 'value' , parseInt(arrGroupDetail[3]));
				break;
		}
		switch (parseInt(arrGroupDetail[4])) { //download data transfer count
			case 0: //no
				elements.dtcDL.selectedIndex = 1;
				break;
			case 1: //yes
				setValue(elements.dtcDL, 'selectedIndex', 2);
				setValue(elements.usageDL, 'value', parseInt(arrGroupDetail[5]));
				setValue(elements.usageDL, 'className', 'noBorder');
				break;
			case 2: //yes and disable account
				setValue(elements.dtcDL,'selectedIndex', 3);
				setValue(elements.usageDL, 'value', parseInt(arrGroupDetail[5]));
				setValue(elements.quotaDL, 'value', parseInt(arrGroupDetail[6]));
				//make usage display in red if it exceed quota
				if (elements.usageDL && elements.quotaDL) {
					if (parseInt(elements.usageDL.value) > parseInt(elements.quotaDL.value)) {
						elements.usageDL.className = 'usageAbnormal';
					} else {
						elements.usageDL.className = 'noBorder';
					}
				}
				break;
			default: //global
				elements.dtcDL.selectedIndex = 0;
				break;
		}
		switch (parseInt(arrGroupDetail[7])) { //upload data transfer count
			case 0: //no
				elements.dtcUL.selectedIndex = 1;
				break;
			case 1: //yes
				setValue(elements.dtcUL, 'selectedIndex', 2);
				setValue(elements.usageUL, 'value', parseInt(arrGroupDetail[8]));
				setValue(elements.usageUL, 'className', 'noBorder');
				break;
			case 2: //yes and disable account
				setValue(elements.dtcUL, 'selectedIndex', 3);
				setValue(elements.usageUL, 'value', parseInt(arrGroupDetail[8]));
				setValue(elements.quotaUL, 'value', parseInt(arrGroupDetail[9]));
				//make usage display in red if it exceed quota
				if (elements.usageUL && elements.quotaUL) {
					if (parseInt(elements.usageUL.value) > parseInt(elements.quotaUL.value)) {
						elements.usageUL.className = 'usageAbnormal';
					} else {
						elements.usageUL.className = 'noBorder';
					}
				}
				break;
			default: //global
				elements.dtcUL.selectedIndex = 0;
				break;
		}
		switch (arrGroupDetail[10]) { //reset usage
			case "disable": //never
				elements.resetDTC.selectedIndex = 1;
				break;
			case "month":
				elements.resetDTC.selectedIndex = 2;
				elements.resetMonthlyDay.value = parseInt(arrGroupDetail[11]);
				elements.resetMonthlyMonth.value = parseInt(arrGroupDetail[12]);
				if (arrGroupDetail[13] > 0){
			    					
			  	var timeArray_date = '';
				  var timeArray_time = '';   
				  var mon, mday, hours, minutes;			
		      var timedate = new Date (arrGroupDetail[13] * 1000 );  //because of milliseconds, lastrbw in terms of sec
		      
		      mon = timedate.getMonth()+1;
		      mon = (mon <10) ? "0"+ mon : mon;
		      mday = (timedate.getDate() <10) ? "0"+timedate.getDate() : timedate.getDate();		      
		      hours = (timedate.getHours() <10) ? "0"+timedate.getHours() : timedate.getHours();
		      minutes = (timedate.getMinutes() <10) ? "0"+timedate.getMinutes() : timedate.getMinutes();
		      
		      timeArray_date = mon+"-"+mday+"-"+timedate.getFullYear();
		      timeArray_time = hours+":"+minutes;
		      
					elements.monthlyResetLastabwDate.value= timeArray_date;
					elements.monthlyResetLastabwTime.value= timeArray_time;
				}
				break;
			case "day":
				elements.resetDTC.selectedIndex = 3;
				elements.resetDailyDay.value = parseInt(arrGroupDetail[12]);
				if (arrGroupDetail[13] > 0){
			    					
			  	var timeArray_date = '';
				  var timeArray_time = '';   
				  var mon, mday, hours, minutes;			
		      var timedate = new Date (arrGroupDetail[13] * 1000 );  //because of milliseconds, lastrbw in terms of sec
		      
		      mon = timedate.getMonth()+1;
		      mon = (mon <10) ? "0"+ mon : mon;
		      mday = (timedate.getDate() <10) ? "0"+timedate.getDate() : timedate.getDate();		      
		      hours = (timedate.getHours() <10) ? "0"+timedate.getHours() : timedate.getHours();
		      minutes = (timedate.getMinutes() <10) ? "0"+timedate.getMinutes() : timedate.getMinutes();
		      
		      timeArray_date = mon+"-"+mday+"-"+timedate.getFullYear();
		      timeArray_time = hours+":"+minutes;
		      
					elements.dailyResetLastabwDate.value= timeArray_date;
					elements.dailyResetLastabwTime.value= timeArray_time;
				}
				break;
			default: //global
				elements.resetDTC.selectedIndex = 0;
				break;
		}
		// 20080422 - Add data transfer sharing part
		switch (parseInt(arrGroupDetail[14])) { // total data transfer count
			case 0: // no
				elements.dtcSha.selectedIndex = 0;
				break;
			case 1: // yes
				setValue(elements.dtcSha, 'selectedIndex', 1);
				setValue(elements.usageSha, 'value', parseInt(arrGroupDetail[15]));
				setValue(elements.usageSha, 'className', 'noBorder');
				break;
			case 2: // yes and disable account
				setValue(elements.dtcSha,'selectedIndex', 2);
				setValue(elements.usageSha, 'value', parseInt(arrGroupDetail[15]));
				setValue(elements.quotaSha, 'value', parseInt(arrGroupDetail[16]));
				// make usage display in red if it exceed quota
				if (elements.usageSha && elements.quotaSha) {
					if (parseInt(elements.usageSha.value) > parseInt(elements.quotaSha.value)) {
						elements.usageSha.className = 'usageAbnormal';
					} else {
						elements.usageSha.className = 'noBorder';
					}
				}
				break;
			default: // no global, set as no
				elements.dtcSha.selectedIndex = 0;
				break;
		}
	}
	adjustDisplay(); //adjust show hide state
}
function makeFormHTML(formName,serverFilename) {
/**
 *	It extract a html form named formName with all its data
 *	and clone it by generating HTML code with action attribute
 *	specified as serverFilename. The HTML code is returned to caller.
 *
 *	@param formName Name of the form being copied
 *	@param serverFilename Filename of the server side secript to handle the form
 *	@return String represent the copied HTML form.
 */
	var formToCopy = document.forms[formName];
	var htmlString = "<form action=\""+serverFilename+"\" method=\"post\">\n";
	var elementType, elementName, elementValue, elementChecked;
	var i,j;
	with (formToCopy) {
		for (i=0; i<elements.length; i++) {
			elementType=elements[i].type;
			elementName=elements[i].name;
			switch (elementType) {
				case "text":
				case "password":
				case "hidden":
					elementValue=elements[i].value;
					htmlString+="<input type=\""+elementType+"\" name=\""+elementName+"\" value=\""+elementValue+"\">\n";
					break;
				case "select-one":
					htmlString+="<select name=\""+elementName+"\">\n";
					with (elements[i]) {
						for (j=0; j<length; j++) {
							elementName=options[j].value; //no name needed in each options
							if (options[j].selected) {
								elementValue = "selected";
							} else {
								elementValue = "";
							}
							htmlString+="<option value=\""+elementName+"\" "+elementValue+">\n";
						}	
					}
					htmlString+="</select>\n";
					break;
				case "radio":
				case "checkbox":
					elementValue=elements[i].value;
					if (elements[i].checked) {
						elementChecked="checked";
					} else {
						elementChecked="";
					}
					htmlString+="<input type=\"radio\" name=\""+elementName+"\" value=\""+elementValue+"\" "+elementChecked+">";
					break;
				default:
					alert('form element not recgonised in makeFormHTML()');
					break;
			} //end switch
		} //end looping each elements in form
	}
	htmlString+="</form>\n";
	return htmlString;
} //end makeFormHTML()

function makeRemoteRequest(formString) {
/**
 *	It initiate remote http request by submitting
 *	a html form inside a invisible iframe in current document.
 *	The request will(and should) response with a html document 
 *	generated by server	side script and notice the parent document 
 *	by calling a parent javascript function rpcxxxReply() with a
 *	message as parameter.
 *	Search 'remote scripting' in google for more information
 *
 *	@param formString The HTML code of the form to be submitted
 */
	var iframeNode = frames['serverFrame']; //iframe set in setcfg.php
	if (iframeNode) { //iframe is there
        var oFrameDoc = iframeNode.document;
		if (oFrameDoc) { //body of iframe is accessible
            oFrameDoc.open();
            oFrameDoc.write('<html><body>');
			oFrameDoc.write(formString); //add a new form in document body of iframe
            oFrameDoc.write('</body></html>');
            oFrameDoc.close();
            if (oFrameDoc.forms[0]) {
                oFrameDoc.forms[0].submit(); //submit the form
            } //end if form in iframe document is ready
		} //end if iframe document is ready
	} //end if there is an iframe 'serverFrame'
}

function displayMessage(message) {
/**
 *	Show up text message at 'messageArea' of the right panel
 *
 *	@param message String represent text to be displayed
 */
	document.getElementById('messageArea').innerHTML = message;	
}

function rpcAddReply(data) {
/**
 *	Receive data from server side script after add group operation.
 *	It then add the sucessfully added group to array glo_arrGroup[].
 *	It display server side message no matter it success or failed.
 *
 *	@param data String with format: [true or false}|[new group name]
 */
	var arrReplyData = data.split('|');
	if (arrReplyData[0]=="") { //add group is successful
		addGroup(arrReplyData[2]);
		refreshGroupList();
		cancel(); //back to view mode
	}
	displayMessage(arrReplyData[1]);
}
function rpcUpdateReply(data) {
/**
 *	Receive data from server side script after update group operation.
 *	It then clear the old information of updated group from array
 *	glo_arrGroup[]. It force the reload of information of updated group
 *	from database and display it right away.
 *	It display server side message no matter it success or failed.
 *
 *	@param data String with format: [true or false}|[group name of the updated group]
 */
	var arrReplyData = data.split('|');
	var listObj = document.getElementById('secretList');
	if (glo_arrGroup[listObj.selectedIndex][0]==arrReplyData[1]) {
		glo_arrGroup[listObj.selectedIndex][1] = ''; //clear the old detail 
	} else {
		for (var i in glo_arrGroup) {
			if (glo_arrGroup[i][0]==arrReplyData[1]) {
				glo_arrGroup[i][1] = ''; //clear the old detail
				break;
			}
		}
	}
	cancel(); //back to view mode
	if (arrReplyData[0]=="1") { //update failed
		clearFormField('frmSecret');
	}
	displayMessage(arrReplyData[2]);
}
function rpcDeleteReply(data) {
/**
 *	Receive data from server side script after delete groups operation.
 *	It then delete the corresponding entries of the server side deleted
 *	group from array glo_arrGroup[]. It force a refresh display of 
 *	secretList.	It display server side message no matter it success 
 *	or failed.
 *
 *	@param data String with format: [true or false}|[list of name of deleted group separated by ',']
 */
	var arrReplyData = data.split('|');
	if (arrReplyData[0]=="") { //delete successfully
		removeGroup(arrReplyData[1]);
		refreshGroupList();
		lookupSecret();
		displayMessage(arrReplyData[2]);
	} else {
		displayMessage(arrReplyData[1]); //display error message
	}
}
function rpcLookupReply(data) {
/**
 *	Receive data from server side script after lookup groups operation.
 *	It then store the returned information into corresponding element of
 *	array glo_arrGroup[]. The new information of the grouped is 
 *	displayed right away. It display server side error message if
 *	lookup failed.
 *
 *	@param data String with format: [true or false}|[group name]|[detailed information of the group separated by ',']
 */
	var arrReplyData = data.split('|');
	var listObj = document.getElementById('secretList');
	if (arrReplyData[0]=="1") {
		displayMessage(arrReplyData[1]); //lookup error
	} else {
		if (glo_arrGroup[listObj.selectedIndex][0]==arrReplyData[1]) {
			//selected group did not change
			glo_arrGroup[listObj.selectedIndex][1] = arrReplyData[2];
		} else {
			//selected group changed, has to search for the group
			for (var i in glo_arrGroup) {
				if (glo_arrGroup[i][0]==arrReplyData[1]) {
					glo_arrGroup[i][1] = arrReplyData[2]; //store the new detail
					break;
				}
			} //end for glo_arrGroup
		}
		lookupSecret();
	} //end if lookup successfully
}

function rpcResetDTCReply(data) {
	var arrReplyData = data.split('|');
	var listObj = document.getElementById('secretList');
	if (arrReplyData[0]=="1") {
		displayMessage(arrReplyData[1]); //error during reset
	} else {
		//reset sucessfully
		var arrGroupToReset = arrReplyData[1].split(',');
		var i=0, j=0; 
		while (i < glo_arrGroup.length) {
			if (j<arrGroupToReset.length && glo_arrGroup[i][0]==arrGroupToReset[j]) {
				//found a match, reset its detail
				glo_arrGroup[i][1] = "";
				i++;	
				j++;
			} else {
				//look for next group
				i++;
			}
		} //end while loop each of glo_arrGroup elements
		clearFormField('frmSecret'); //reset current display
		listObj.selectedIndex = -1; //unselect current selected option
		displayMessage(arrReplyData[2]);
	} //end if no error
}

function saveOnclick() {
/**
 *	It trigger server side script according to user request. It perform
 *	add or edit group by using remote scripting.
 */
	var saveBtn = document.getElementById('save');
	var formHTML;
	if (validateFrmSecret()) {
		if (saveBtn.getAttribute('mode') == "add") {
			formHTML = makeFormHTML('frmSecret','addGroup.php');
		} else if (saveBtn.getAttribute('mode') == "edit") {
			formHTML = makeFormHTML('frmSecret','updateGroup.php');
		}
		makeRemoteRequest(formHTML);
	}
}
function deleteGroup() {
/**
 *	It collect the names of all selected groups. Ask user for confirm
 *	deletion. And then trigger the server side deletion by using remote
 *	scripting.
 */
	var listObj = document.getElementById('secretList');
	var arrGroupToDelete = new Array();
	var i = 0;
	with (listObj) {
		for (var y=0; y < length; y++) {
			if (options[y].selected) {	 
				arrGroupToDelete[i] = options[y].text;
				i++;
			}
		}
	}
	if (i < 1) { //no group selected
		alert(glo_jsMessage.ssecret_js_alert_delete_nogroup);
	} else {
		if (confirm(arrGroupToDelete.length + glo_jsMessage.ssecret_js_alert_delete_confirm)) {
			var formHTML = "<form action=\"deleteGroup.php\" method=\"post\">";
			formHTML += "<input type=\"hidden\" name=\"deleteString\" value=\"" + arrGroupToDelete.join(',') + "\">";
			formHTML += "</form>";
			makeRemoteRequest(formHTML);
		}
	}
}
function resetGroup() {
/**
 *	It collect the names of all selected groups. Ask user for confirm
 *	reset. And then trigger the server side deletion by using remote
 *	scripting.
 */
	var listObj = document.getElementById('secretList');
	var arrGroupToReset = new Array();
	var i = 0;
	with (listObj) {
		for (var y=0; y < length; y++) {
			if (options[y].selected) {	 
				arrGroupToReset[i] = options[y].text;
				i++;
			}
		}
	}
	if (i < 1) { //no group selected
		alert(glo_jsMessage.ssecret_js_alert_resetDTC_nogroup);
	} else {
		if (confirm(glo_jsMessage.ssecret_js_alert_resetDTC_confirm_1 + arrGroupToReset.length + glo_jsMessage.ssecret_js_alert_resetDTC_confirm_2)) {
			var formHTML = "<form action=\"resetDtcOfGroup.php\" method=\"post\">";
			formHTML += "<input type=\"hidden\" name=\"resetString\" value=\"" + arrGroupToReset.join(',') + "\">";
			formHTML += "</form>";
			makeRemoteRequest(formHTML);
		}
	}
}
function showPasswordItem(displayString) {
/**
 *	Show or hide the two rows of the form containing password field.
 *
 *	@param displayString String indicating display type of the two rows
 */
	var obj = findParentElementWithTagName(document.frmSecret.secretCode, 'LI');
	obj.style.display = displayString;
	obj = findParentElementWithTagName(document.frmSecret.confirmSecretCode, 'LI');
	obj.style.display = displayString;
}
function findParentElementWithTagName(obj, tagname) {
/**
 *	Search the document tree upward to find a closest element having a 
 *	given tab name.
 *
 *	@param obj Object from which the search start
 *	@param tagname String indicating elements of which type it is looking for
 *	@return Object reference of the search result
 */
	if (obj.tagName == tagname) {
		return obj;
	} else {
		return findParentElementWithTagName(obj.parentNode, tagname);
	}
}
function refreshPage() {
	location.reload(true);
}
function exportGroup()
{
/**
 *	It call server side script to export shared secret database
 *	table to a csv file.
 */
	var formHTML = '<form action="exportGroup.php" method="post"></form>';
	makeRemoteRequest(formHTML);
}
function importGroup()
{
/**
 *	It call server side script to import a csv file to shared secret database
 *	table.
 */
	var formHTML = "<form action=\"importGroup.php\" method=\"post\"></form>";
	makeRemoteRequest(formHTML);
}

function getEvent(evt)
{
    //for cross browser compatibility
    evt = (evt) ? evt : ((window.event) ? event : null);
    return evt;
}

function getEventElement(evt)
{
    //for cross browser compatibility
    var elem = null;
    evt = (evt) ? evt : ((window.event) ? event : null);
    if (evt) {
        elem = (evt.target) ? evt.target : 
            ((evt.srcElement) ? evt.srcElement : null);
    }
    return elem;
}

 
function warnMonthDate(elementName)
{
/*
 *	Make a warning 
 *
 *	@param elementName the name of the form element being validated.
 *	@alert warning when date > 28
 */
	var obj = document.forms.frmSecret.elements[elementName];
	var ok = true;
	if (obj) {
		if (!obj.disabled && obj.value>28 ) {
			alert(glo_jsMessage.ssecret_js_alert_warningDate);
		}
	}
	return ok;
}
		
function timeFormat(elementName1, elementName2)
{
/*
 *	Check the time Format
 *
 *	@param elementName1 and elementName2 the name of the form element being validated.
 *	@alert when time not correct syntax (hh:mm) 
 */
	var obj1 = document.forms.frmSecret.elements[elementName1];
	var obj2 = document.forms.frmSecret.elements[elementName2];
	var ok = true;
	if (obj1 && obj2) {
		if (!obj2.disabled && !isTime(obj2.value)  && ( !isEmpty(obj2.value) || (isEmpty(obj2.value) && !isEmpty(obj1.value)) ) ){
			alert(glo_jsMessage.ssecret_js_alert_time);
			obj2.select();
			return false;
		}
	}
	return ok;
}

function dateFormat(elementName1, elementName2)
{
/*
 *	Check the date Format
 *
 *	@param elementName1 and elementName2 the name of the form element being validated.
 *	@alert when date not correct syntax (mm-dd-yyy) 
 */
 
	var obj1 = document.forms.frmSecret.elements[elementName1];
	var obj2 = document.forms.frmSecret.elements[elementName2];
	var ok = true;
	if (obj1 && obj2) {
		if (!obj1.disabled && !isDate(obj1.value, obj2.value) && ( !isEmpty(obj1.value) || (isEmpty(obj1.value) && !isEmpty(obj2.value)) ) ){
			alert(glo_jsMessage.ssecret_js_alert_date);
			obj1.select();
			return false;
		}
	}
	
	return ok;
}

// 20080423 - Check to disable UL and DL DTC if total DTC is enabled
function NotifyEnableDtcTotal(elementNameSha, elementNameDl, elementNameDlQuota, elementNameUl, elementNameUlQuota)
{
    var objSha = document.forms.frmSecret.elements[elementNameSha];
    var objDl = document.forms.frmSecret.elements[elementNameDl];
    var objDlQuota = document.forms.frmSecret.elements[elementNameDlQuota];
    var objUl = document.forms.frmSecret.elements[elementNameUl];
    var objUlQuota = document.forms.frmSecret.elements[elementNameUlQuota];
    var ok = true;

    if (objSha && objDl && objUl) {
	if (objSha.value == 'yes' || objSha.value == 'yesDisable') {
	    alert(glo_jsMessage.ssecret_js_alert_dtc_total);
	    objDl.value = 'no';
	    objUl.value = 'no';
	    objDlQuota.value = '0';
	    objUlQuota.value = '0';
	}
    }

    return ok;
}
