<?php
    header("Cache-Control: no-cache, must-revalidate");
    require_once("secureLogin.php"); //for security reason
    include_once("cmvar.php");
    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("manageSecret.php FSCONFIG.Cfgmgr Object cannot be created!");

    // find out version information
    $version = strtolower($settingobj->getKey( "version", "version"));

	// 20090518 - Add Premium
	$isPerUserBT = $version=="trial" || $version == "advanced" || $version == 'premium';
	$isDataTransferCount = $version == "trial" || $version == "standard" || $version == "advanced" || $version == 'premium';
	$isDataTransferQuota = $version == "trial" || $version == "advanced" || $version == 'premium';

    // obtain low, medium or high BT value from config.ini
    $outval = $settingobj->getKey( "bt_low", "bw_throttle");        
    if($outval!="") $low=$outval;
    $outval = $settingobj->getKey( "bt_medium", "bw_throttle");       
    if($outval!="") $medium=$outval;
    $outval = $settingobj->getKey( "bt_high", "bw_throttle");
    if($outval!="") $high=$outval;

    //find database source
    $dsn_file=$settingobj->getKey( "Datasource", "gateway");
    $dsn_source=fopen($dsn_file, "r") or die("Cannot open DSN source file!");
    $dsn="";
    if (!feof($dsn_source)) { $line=fgets($dsn_source,512); }
    while (!feof($dsn_source)) {
      $line=fgets($dsn_source,512);
      if (trim($line)!="") $dsn=$dsn.$line;
    }
    fclose($dsn_source);
    $dsn=str_replace("\r\n",";",$dsn);

    //find secret table name
    $sharedSecretTablename = $settingobj->getKey( "Datasource_Shared_Secret_Tablename", "gateway");

    //release COM object
    //$settingobj->Release();
    $settingobj = null;


    $secretDB = odbc_connect($dsn,"","");
    if ($secretDB) {
        $query = "SELECT groupname FROM $sharedSecretTablename ORDER BY groupname";
        $result = odbc_exec($secretDB,$query);
        while (odbc_fetch_row($result)) {
            $gpName = odbc_result($result,"groupname");
            $arrayOfGroup[] = "['$gpName', '']";
        } //end of looping through all query result
        odbc_close($secretDB);
    } else {
        //database connection failed
    }
    if (!isset($arrayOfGroup)) {
        $arrayOfGroup[] = "";
    }
?>
<html>
<head>
<link href="manageGroup.css" rel="stylesheet">
<script type="text/javascript">
glo_arrGroup = [<?=implode(',', $arrayOfGroup)?>];
glo_jsMessage = new Object();
// 20080423 - Add dtc_total
glo_jsMessage.ssecret_js_alert_secret = '<?=get_cm_var('ssecret_js_alert_secret')?>';
glo_jsMessage.ssecret_js_alert_secret_unmatch = '<?=get_cm_var('ssecret_js_alert_secret_unmatch')?>';
glo_jsMessage.ssecret_js_alert_gpname_nospace = '<?=get_cm_var('ssecret_js_alert_gpname_nospace')?>';
glo_jsMessage.ssecret_js_alert_integer = '<?=get_cm_var('ssecret_js_alert_integer')?>';
glo_jsMessage.ssecret_js_alert_day = '<?=get_cm_var('ssecret_js_alert_day')?>';
glo_jsMessage.ssecret_js_alert_delete_nogroup = '<?=get_cm_var('ssecret_js_alert_delete_nogroup')?>';
glo_jsMessage.ssecret_js_alert_edit_nogroup = '<?=get_cm_var('ssecret_js_alert_edit_nogroup')?>';
glo_jsMessage.ssecret_js_alert_delete_confirm = '<?=get_cm_var('ssecret_js_alert_delete_confirm')?>';
glo_jsMessage.ssecret_js_alert_resetDTC_confirm_1= '<?=get_cm_var('ssecret_js_alert_resetDTC_confirm_1')?>';
glo_jsMessage.ssecret_js_alert_resetDTC_confirm_2= '<?=get_cm_var('ssecret_js_alert_resetDTC_confirm_2')?>';
glo_jsMessage.ssecret_js_alert_resetDTC_nogroup= '<?=get_cm_var('ssecret_js_alert_resetDTC_nogroup')?>';
glo_jsMessage.ssecret_js_alert_warningDate= '<?=get_cm_var('js_alert_users_26')?>';
glo_jsMessage.ssecret_js_alert_time= '<?=get_cm_var('js_alert_users_27')?>';
glo_jsMessage.ssecret_js_alert_date= '<?=get_cm_var('js_alert_users_28')?>';
glo_jsMessage.ssecret_js_alert_dtc_total = '<?=get_cm_var('ssecret_js_alert_dtc_total')?>';

</script>
<?php
echo '<script type="text/javascript">';
require_once 'javascript//validate.js';
echo '</script>';
?>
<script type="text/javaScript" src="./javascript/manageGroup.js"></script>
</head>
<body>
    <div id="leftPanel" class="leftPanel">
    <h5>
        <input type="button" value="<?=get_cm_var('ssecret_btn_list_header')?>" class="btnTitle"/>
        <input type="button" id="refresh" value="<?=get_cm_var('ssecret_btn_refresh')?>" title="<?=get_cm_var('ssecret_title_refresh')?>" class="btn"/>
    </h5>
        <select id="secretList" size="15" multiple>
        </select>
        <h6>
            <input type="button" id="delete" class="btn" value="<?=get_cm_var('ssecret_btn_delete')?>" title="<?=get_cm_var('ssecret_title_delete')?>"/>
        </h6>
    </div>
    <input type="button" id="view" class="view" value="<?=get_cm_var('ssecret_btn_view')?>" title="<?=get_cm_var('ssecret_title_view')?>"/>
    <input type="button" id="add" class="add" value="<?=get_cm_var('ssecret_btn_add')?>" title="<?=get_cm_var('ssecret_title_add')?>"/>
    <input type="button" id="edit" class="edit" value="<?=get_cm_var('ssecret_btn_edit')?>" title="<?=get_cm_var('ssecret_title_edit')?>"/>
    <div id="rightPanel" class="rightPanelView">
        <form name="frmSecret">
            <ul id="level1">
                <li>
                    <label class="leftLabel"><?=get_cm_var('ssecret_group_name')?></label>
                    <input type="text" id="gpName" name="gpName" size="20" maxlength="40" dv="" disabled/>
                <li>
                    <label class="leftLabel"><?=get_cm_var('ssecret_secret_code')?></label>
                    <input type="password" name="secretCode" size="20" maxlength="40" dv="     " disabled/>
                <li>
                    <label class="leftLabel"><?=get_cm_var('ssecret_confirm_secret_code')?></label>
                    <input type="password" name="confirmSecretCode" size="20" maxlength="40" dv="     " disabled/>
                <li>
                    <label class="leftLabel"><?=get_cm_var('ssecret_bt')?></label>
                    <select name="bt" disabled>
                        <option value="global" selected/><?=get_cm_var('ssecret_bt_global')?>
                        <option value="no"/><?=get_cm_var('ssecret_bt_no')?>
<?php
    if ($isPerUserBT) {
?>
                        <option value="low"/><?=get_cm_var('ssecret_bt_low')?> (<?=$low?> <?=get_cm_var('ssecret_unit_kbps')?>)
                        <option value="medium"/><?=get_cm_var('ssecret_bt_medium')?> (<?=$medium?> <?=get_cm_var('ssecret_unit_kbps')?>)
                        <option value="high"/><?=get_cm_var('ssecret_bt_high')?> (<?=$high?> <?=get_cm_var('ssecret_unit_kbps')?>)
                        <option value="specify" subElement="btSpecifyUL,btSpecifyDL"/><?=get_cm_var('ssecret_bt_specify')?>
<?php
    }
?>
                    </select>
<?php
    if ($isPerUserBT) {
?>
                    <ul>
                        <li id="btSpecifyUL">
                            <label class="leftLabel"><?=get_cm_var('ssecret_bt_upload')?></label>
                            <input type="text" name="btUL" size="6" maxlength="10" dv="" disabled/>
                            <label><?=get_cm_var('ssecret_unit_kbps')?></label>
                        <li id="btSpecifyDL">
                            <label class="leftLabel"><?=get_cm_var('ssecret_bt_download')?></label>
                            <input type="text" name="btDL" size="6" maxlength="10" dv="" disabled/>
                            <label><?=get_cm_var('ssecret_unit_kbps')?></label>
                    </ul>
<?php
    }
?>
                <li>
                    <label class="leftLabel"><?=get_cm_var('ssecret_dtcUL')?></label>
                    <select name="dtcUL" disabled>
                        <option value="global" selected/><?=get_cm_var('ssecret_dtcUL_global')?>
                        <option value="no"/><?=get_cm_var('ssecret_dtcUL_no')?>
<?php
    if ($isDataTransferCount) {
?>
                        <option value="yes" subElement="dtcULUsage"/><?=get_cm_var('ssecret_dtcUL_yes')?>
<?
    }
    if ($isDataTransferQuota) {
?>

                        <option value="yesDisable" subElement="dtcULQuota,dtcULAddQuota,dtcULUsage"/><?=get_cm_var('ssecret_dtcUL_yes_disable')?>
<?
    }
?>
                    </select>
                    <ul>
<?
    if ($isDataTransferQuota) {
?>
                        <li id="dtcULQuota">
                            <label class="leftLabel"><?=get_cm_var('ssecret_dtcUL_quota')?></label>
                            <input type="text" name="quotaUL" size="6" maxlength="10" dv="" disabled/>
                            <label><?=get_cm_var('ssecret_unit_kb')?></label>
                        <li id="dtcULAddQuota">
                            <label class="leftLabel"><?=get_cm_var('ssecret_dtcUL_addQuota')?></label>
                            <input type="text" name="addQuotaUL" size="6" maxlength="10" dv="" disabled/>
                            <label><?=get_cm_var('ssecret_unit_kb')?></label>
<?
    }
    if ($isDataTransferCount) {
?>
                        <li id="dtcULUsage">
                            <label class="leftLabel"><?=get_cm_var('ssecret_dtcUL_usage')?></label>
                            <input class="noBorder" type="text" name="usageUL" size="6" maxlength="10" dv="0" readonly/>
                            <label><?=get_cm_var('ssecret_unit_kb')?></label>
<?
    }
?>
                    </ul>
                <li>
                    <label class="leftLabel"><?=get_cm_var('ssecret_dtcDL')?></label>
                    <select name="dtcDL" disabled>
                        <option value="global" selected/><?=get_cm_var('ssecret_dtcDL_global')?>
                        <option value="no"/><?=get_cm_var('ssecret_dtcDL_no')?>
<?
    if ($isDataTransferCount) {
?>
                        <option value="yes" subElement="dtcDLUsage"/><?=get_cm_var('ssecret_dtcDL_yes')?>
<?
    }
    if ($isDataTransferQuota) {
?>
                        <option value="yesDisable" subElement="dtcDLQuota,dtcDLAddQuota,dtcDLUsage"/><?=get_cm_var('ssecret_dtcDL_yes_disable')?>
<?
    }
?>
                    </select>
                    <ul>
<?
    if ($isDataTransferQuota) {
?>
                        <li id="dtcDLQuota">
                            <label class="leftLabel"><?=get_cm_var('ssecret_dtcDL_quota')?></label>
                            <input type="text" name="quotaDL" size="6" maxlength="10" dv="" disabled/>
                            <label><?=get_cm_var('ssecret_unit_kb')?></label>
                        <li id="dtcDLAddQuota">
                            <label class="leftLabel"><?=get_cm_var('ssecret_dtcDL_addQuota')?></label>
                            <input type="text" name="addQuotaDL" size="6" maxlength="10" dv="" disabled/>
                            <label><?=get_cm_var('ssecret_unit_kb')?></label>
<?
    }
    if ($isDataTransferCount) {
?>
                        <li id="dtcDLUsage">
                            <label class="leftLabel"><?=get_cm_var('ssecret_dtcDL_usage')?></label>
                            <input class="noBorder" type="text" name="usageDL" size="6" maxlength="10" dv="0" readonly/>
                            <label><?=get_cm_var('ssecret_unit_kb')?></label>
<?
    }
    // 20080422 - Add data transfer sharing row
?>
                    </ul>
                <li>
                    <label class="leftLabel"><?=get_cm_var('ssecret_dtcSha')?></label>
                    <select name="dtcSha" disabled>
                        <option value="no" selected/><?=get_cm_var('ssecret_dtcSha_no')?>
<?
    if ($isDataTransferCount) {
?>
                        <option value="yes" subElement="dtcShaUsage"/><?=get_cm_var('ssecret_dtcSha_yes')?>
<?
    }
    if ($isDataTransferQuota) {
?>
                        <option value="yesDisable" subElement="dtcShaQuota,dtcShaAddQuota,dtcShaUsage"/><?=get_cm_var('ssecret_dtcSha_yes_disable')?>
<?
    }
?>
                    </select>
                    <ul>
<?
    if ($isDataTransferQuota) {
?>
                        <li id="dtcShaQuota">
                            <label class="leftLabel"><?=get_cm_var('ssecret_dtcSha_quota')?></label>
                            <input type="text" name="quotaSha" size="6" maxlength="10" dv="" disabled/>
                            <label><?=get_cm_var('ssecret_unit_kb')?></label>
                        <li id="dtcShaAddQuota">
                            <label class="leftLabel"><?=get_cm_var('ssecret_dtcSha_addQuota')?></label>
                            <input type="text" name="addQuotaSha" size="6" maxlength="10" dv="" disabled/>
                            <label><?=get_cm_var('ssecret_unit_kb')?></label>
<?
    }
    if ($isDataTransferCount) {
?>
                        <li id="dtcShaUsage">
                            <label class="leftLabel"><?=get_cm_var('ssecret_dtcSha_usage')?></label>
                            <input class="noBorder" type="text" name="usageSha" size="6" maxlength="10" dv="0" readonly/>
                            <label><?=get_cm_var('ssecret_unit_kb')?></label>
<?
    }
?>
                    </ul>
                <li>
                    <label class="leftLabel"><?=get_cm_var('ssecret_resetDTC')?></label>
                    <select name="resetDTC" disabled>
                        <option value="global" selected/><?=get_cm_var('ssecret_resetDTC_global')?>
                        <option value="never"/><?=get_cm_var('ssecret_resetDTC_never')?>
                        <option value="monthly" subElement="resetMonthly"/><?=get_cm_var('ssecret_resetDTC_monthly')?>
                        <option value="daily" subElement="resetDaily"/><?=get_cm_var('ssecret_resetDTC_daily')?>
                    </select>
                    <ul>
                        <li id="resetMonthly">
                            <label class="leftLabel"><?=get_cm_var('ssecret_resetDTC_monthly_1')?></label>
                            <input type="text" name="resetMonthlyDay" size="3" maxlength="2" dv="" disabled/>
                            <label><?=get_cm_var('ssecret_resetDTC_monthly_2')?></label>
                            <input type="text" name="resetMonthlyMonth" size="3" maxlength="3" dv="" disabled/>
                            <label><?=get_cm_var('ssecret_resetDTC_monthly_3')?></label>
                            <br>
                            <label class="leftLabel"><br><?=get_cm_var('setcfg_dispatcher_resetabw_title2')?></label>
                            <label>(<?=get_cm_var('setcfg_date_format')?>)&nbsp;(<?=get_cm_var('setcfg_time_format')?>)</label> <br>
                            <input type="text" name="monthlyResetLastabwDate" size="10" maxlength="10" dv="" disabled/>
                            <label> </label>
                            <input type="text" name="monthlyResetLastabwTime" size="5" maxlength="5" dv="" disabled/>
                            <label> </label>
                        <li id="resetDaily">
                            <label class="leftLabel"><?=get_cm_var('ssecret_resetDTC_daily_1')?></label>
                            <input type="text" name="resetDailyDay" size="4" maxlength="5" dv="" disabled>
                            <label><?=get_cm_var('ssecret_resetDTC_daily_2')?></label>
                            <br>
                            <label class="leftLabel"><br><?=get_cm_var('setcfg_dispatcher_resetabw_title2')?></label>
                            <label>(<?=get_cm_var('setcfg_date_format')?>)&nbsp;(<?=get_cm_var('setcfg_time_format')?>)</label> <br>
                            <input type="text" name="dailyResetLastabwDate" size="10" maxlength="10" dv="" disabled/>
                            <label> </label>
                            <input type="text" name="dailyResetLastabwTime" size="5" maxlength="5" dv="" disabled/>
                            <label> </label>
                    </ul>
            </ul>
        </form>
        <h6 id="rightPanelFooter" class="rightPanelFooterView">
            <input type="button" id="save" name="save" value="<?=get_cm_var('ssecret_btn_save')?>" mode="" class="btn" title="<?=get_cm_var('ssecret_title_save')?>"/>
            <input type="button" id="cancel" name="cancel" value="<?=get_cm_var('ssecret_btn_cancel')?>" class="btn" title="<?=get_cm_var('ssecret_title_cancel')?>"/>
            <span id="messageArea" class="messageArea"></span>
        </h6>
    </div>
    <div id="bottomPanel" class="bottomPanel">
        <input type="button" id="resetDtcBtn" class="graphicBtn" value="<?=get_cm_var('ssecret_btn_resetDTC')?>" title="<?=get_cm_var('ssecret_title_resetDTC')?>"/>
        <br/>
        <input type="button" id="exportGroup" class="graphicBtn" value="<?=get_cm_var('ssecret_btn_export')?>" title="<?=get_cm_var('ssecret_btn_export')?>"/>
        <input type="button" id="importGroup" class="graphicBtn" value="<?=get_cm_var('ssecret_btn_import')?>" title="<?=get_cm_var('ssecret_btn_import')?>"/>
    </div>
<!-- this iframe is for remote scripting -->
<iframe id="serverFrame" name="serverFrame" src="about:blank" style="width:0px; height:0px; border:0px;"></iframe>
</body>
<script type="text/javascript">
init();
</script>
</html>
