<?php

require_once 'fs_lang.php';
require_once 'common_functions.php';
require_once 'generate_common.php';

// 20090203 - Add labels starting from timeleft_user
$text_timeleft = get_var('timeleft_header');
$text_unlimited = get_var('Unlimited');
$text_less_than_1min = get_var('last_than_one_min');
$text_unit_minute = get_var('Min');
$text_user = get_var('timeleft_user');
$text_expiry_date_time = get_var('timeleft_expiry_date_time');
$text_bw_quota_dl_limit = get_var('timeleft_bw_quota_dl_limit');
$text_bw_quota_dl_consumed = get_var('timeleft_bw_quota_dl_consumed');
$text_bw_quota_ul_limit = get_var('timeleft_bw_quota_ul_limit');
$text_bw_quota_ul_consumed = get_var('timeleft_bw_quota_ul_consumed');
$text_bw_quota_sha_limit = get_var('timeleft_bw_quota_sha_limit');
$text_bw_quota_sha_consumed = get_var('timeleft_bw_quota_sha_consumed');
$text_print_quota = get_var('timeleft_print_quota');

// check if session_username is present
// if not, divert to cookies warning page
if(!session_id())
	session_start();

// 20090204 - Add checking length of username
if (isset($_SESSION['session_username']) && strlen($_SESSION['session_username']) > 0) {
	$username = $_SESSION['session_username'];
} else {
	header('Location: cookies_warning.php');
	exit;
}

// 20090427 - Block if RADIUS mode
$settingObj = new COM('FSCONFIG.Cfgmgr') or die('timeleft.php FSCONFIG.Cfgmgr Object cannot be created!');
$useRadius = $settingObj->getKey('use_radius', 'radius');
$settingObj = null;
if (strtolower($useRadius) == 'true') {
    $inputStr = '<span class="boldtextspan">'.get_var('timeleft_radius_not_support').'</span><br>';
    GenTable('', $inputStr, '');
}

// 20090327 - Show DB error page
// 20090204 - Obtain detailed account information, check if enough elements are returned
$aAccUsage = array();
$timeLeftResult = fs_timeleft($username);
if ($timeLeftResult == FALSE) {
    $inputStr = '<span class="boldtextspan">'.get_var('login_database_unavailable').'</span><br>';
    GenTable('', $inputStr, '');
}
$aAccUsage = explode('|', $timeLeftResult);
if (count($aAccUsage) < 9) {
    header('Location: cookies_warning.php');
    exit;
}

// 20090204 - Modify time left part
// will only continue otherwise
$timeleft = (int)$aAccUsage[0];
if ($timeleft == -1)
	$text_minute = $text_less_than_1min;
else if ($timeleft == -2)
	$text_minute = $text_unlimited;
else
	$text_minute = $timeleft;

$myObj = new COM('FSAUTH.Authserv') or die('timeleft.php FSAUTH.Authserv object cannot be created!');
$patronsoft2 = $_SESSION['sess_patronsoft2'];
$sSessBwAll = $myObj->QueryBW($patronsoft2);
$myObj = null;

list($sessBwDl, $sessBwUl, $sessBwSha) = explode(',', $sSessBwAll);
settype($sessBwDl, 'integer');
settype($sessBwUl, 'integer');
settype($sessBwSha, 'integer');

$sBwQuotaDlLimit = '';
$sBwQuotaDlConsumed = '';
if ($aAccUsage[2] != '') {
    $iTmp = (int)$aAccUsage[2];
    if ($iTmp < 1024) {
	$sBwQuotaDlLimit = $iTmp.' KB';
    } elseif ($iTmp < 1048576) {
	$sBwQuotaDlLimit = round($iTmp / 1024, 2).' MB';
    } else {
	$sBwQuotaDlLimit = round($iTmp / 1048576, 2).' GB';
    }
    $iTmp = (int)$aAccUsage[3] + $sessBwDl;
    if ($iTmp < 1024) {
	$sBwQuotaDlConsumed = $iTmp.' KB';
    } elseif ($iTmp < 1048576) {
	$sBwQuotaDlConsumed = round($iTmp / 1024, 2).' MB';
    } else {
	$sBwQuotaDlConsumed = round($iTmp / 1048576, 2).' GB';
    }
}

$sBwQuotaUlLimit = '';
$sBwQuotaUlConsumed = '';
if ($aAccUsage[4] != '') {
    $iTmp = (int)$aAccUsage[4];
    if ($iTmp < 1024) {
	$sBwQuotaUlLimit = $iTmp.' KB';
    } elseif ($iTmp < 1048576) {
	$sBwQuotaUlLimit = round($iTmp / 1024, 2).' MB';
    } else {
	$sBwQuotaUlLimit = round($iTmp / 1048576, 2).' GB';
    }
    $iTmp = (int)$aAccUsage[5] + $sessBwUl;
    if ($iTmp < 1024) {
	$sBwQuotaUlConsumed = $iTmp.' KB';
    } elseif ($iTmp < 1048576) {
	$sBwQuotaUlConsumed = round($iTmp / 1024, 2).' MB';
    } else {
	$sBwQuotaUlConsumed = round($iTmp / 1048576, 2).' GB';
    }
}

$sBwQuotaShaLimit = '';
$sBwQuotaShaConsumed = '';
if ($aAccUsage[6] != '') {
    $iTmp = (int)$aAccUsage[6];
    if ($iTmp < 1024) {
	$sBwQuotaShaLimit = $iTmp.' KB';
    } elseif ($iTmp < 1048576) {
	$sBwQuotaShaLimit = round($iTmp / 1024, 2).' MB';
    } else {
	$sBwQuotaShaLimit = round($iTmp / 1048576, 2).' GB';
    }
    $iTmp = (int)$aAccUsage[7] + $sessBwSha;
    if ($iTmp < 1024) {
	$sBwQuotaShaConsumed = $iTmp.' KB';
    } elseif ($iTmp < 1048576) {
	$sBwQuotaShaConsumed = round($iTmp / 1024, 2).' MB';
    } else {
	$sBwQuotaShaConsumed = round($iTmp / 1048576, 2).' GB';
    }
}

// 20090204 - Add tags starting from TEXT_USER
// 20080407 - Collect dynamic HTML content for layout
$smarty = new SmartyConnect;
$smarty->assign('L_TIMELEFT_CHARSET', metaCharset());
$smarty->assign('L_TIMELEFT_TEXT', $text_timeleft);
$smarty->assign('L_TIMELEFT_USERNAME', $username);
$smarty->assign('L_TIMELEFT_MINUTE', $text_minute);
$smarty->assign('J_COMMON', $j_common);
$smarty->assign('L_TIMELEFT_TEXT_USER', $text_user);
if ($aAccUsage[1] == '') {
    $smarty->assign('L_TIMELEFT_EXPIRY_DATE_TIME_COMMENT_OPEN', '<!--');
    $smarty->assign('L_TIMELEFT_EXPIRY_DATE_TIME_COMMENT_CLOSE', '-->');
} else {
    $smarty->assign('L_TIMELEFT_EXPIRY_DATE_TIME_COMMENT_OPEN', '');
    $smarty->assign('L_TIMELEFT_EXPIRY_DATE_TIME_COMMENT_CLOSE', '');
}
$smarty->assign('L_TIMELEFT_TEXT_EXPIRY_DATE_TIME', $text_expiry_date_time);
$smarty->assign('L_TIMELEFT_EXPIRY_DATE_TIME', $aAccUsage[1]);
if ($sBwQuotaDlLimit == '') {
    $smarty->assign('L_TIMELEFT_BW_QUOTA_DL_COMMENT_OPEN', '<!--');
    $smarty->assign('L_TIMELEFT_BW_QUOTA_DL_COMMENT_CLOSE', '-->');
} else {
    $smarty->assign('L_TIMELEFT_BW_QUOTA_DL_COMMENT_OPEN', '');
    $smarty->assign('L_TIMELEFT_BW_QUOTA_DL_COMMENT_CLOSE', '');
}
$smarty->assign('L_TIMELEFT_TEXT_BW_QUOTA_DL_LIMIT', $text_bw_quota_dl_limit);
$smarty->assign('L_TIMELEFT_BW_QUOTA_DL_LIMIT', $sBwQuotaDlLimit);
$smarty->assign('L_TIMELEFT_TEXT_BW_QUOTA_DL_CONSUMED', $text_bw_quota_dl_consumed);
$smarty->assign('L_TIMELEFT_BW_QUOTA_DL_CONSUMED', $sBwQuotaDlConsumed);
if ($sBwQuotaUlLimit == '') {
    $smarty->assign('L_TIMELEFT_BW_QUOTA_UL_COMMENT_OPEN', '<!--');
    $smarty->assign('L_TIMELEFT_BW_QUOTA_UL_COMMENT_CLOSE', '-->');
} else {
    $smarty->assign('L_TIMELEFT_BW_QUOTA_UL_COMMENT_OPEN', '');
    $smarty->assign('L_TIMELEFT_BW_QUOTA_UL_COMMENT_CLOSE', '');
}
$smarty->assign('L_TIMELEFT_TEXT_BW_QUOTA_UL_LIMIT', $text_bw_quota_ul_limit);
$smarty->assign('L_TIMELEFT_BW_QUOTA_UL_LIMIT', $sBwQuotaUlLimit);
$smarty->assign('L_TIMELEFT_TEXT_BW_QUOTA_UL_CONSUMED', $text_bw_quota_ul_consumed);
$smarty->assign('L_TIMELEFT_BW_QUOTA_UL_CONSUMED', $sBwQuotaUlConsumed);
if ($sBwQuotaShaLimit == '' || $sBwQuotaDlLimit != '' || $sBwQuotaUlLimit != '') {
    $smarty->assign('L_TIMELEFT_BW_QUOTA_SHA_COMMENT_OPEN', '<!--');
    $smarty->assign('L_TIMELEFT_BW_QUOTA_SHA_COMMENT_CLOSE', '-->');
} else {
    $smarty->assign('L_TIMELEFT_BW_QUOTA_SHA_COMMENT_OPEN', '');
    $smarty->assign('L_TIMELEFT_BW_QUOTA_SHA_COMMENT_CLOSE', '');
}
$smarty->assign('L_TIMELEFT_TEXT_BW_QUOTA_SHA_LIMIT', $text_bw_quota_sha_limit);
$smarty->assign('L_TIMELEFT_BW_QUOTA_SHA_LIMIT', $sBwQuotaShaLimit);
$smarty->assign('L_TIMELEFT_TEXT_BW_QUOTA_SHA_CONSUMED', $text_bw_quota_sha_consumed);
$smarty->assign('L_TIMELEFT_BW_QUOTA_SHA_CONSUMED', $sBwQuotaShaConsumed);
if ($aAccUsage[8] == '') {
    $smarty->assign('L_TIMELEFT_PRINT_QUOTA_COMMENT_OPEN', '<!--');
    $smarty->assign('L_TIMELEFT_PRINT_QUOTA_COMMENT_CLOSE', '-->');
} else {
    $smarty->assign('L_TIMELEFT_PRINT_QUOTA_COMMENT_OPEN', '');
    $smarty->assign('L_TIMELEFT_PRINT_QUOTA_COMMENT_CLOSE', '');
}
$smarty->assign('L_TIMELEFT_TEXT_PRINT_QUOTA', $text_print_quota);
$smarty->assign('L_TIMELEFT_PRINT_QUOTA', $aAccUsage[8]);

// 20080407 - Move layout content and include the file here
$smarty->display('timeleft_body.tpl');

?>
